SystemOrganization addCategory: #'OB-Tests-Standard'!

TestCase subclass: #OBAncestryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBAncestryTest methodsFor: 'asserting' stamp: ''!
assert: ancestor isAncestorOf: descendant
	self assert: (ancestor isAncestorOf: descendant)! !

!OBAncestryTest methodsFor: 'asserting' stamp: ''!
deny: ancestor isAncestorOf: descendant
	self deny: (ancestor isAncestorOf: descendant)! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testClassCategoryIdentity
	self 
		assert: (OBClassCategoryNode on: 'Bogus-Base' inEnvironment: Smalltalk) 
		isAncestorOf: (OBClassCategoryNode on: 'Bogus-Base' inEnvironment: Smalltalk).
! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testClassCategoryOther
	self 
		deny: (OBClassCategoryNode on: 'Bogus-Base' inEnvironment: Smalltalk)
		isAncestorOf: (OBClassCategoryNode on: 'Bogus-Formats' inEnvironment: Smalltalk)
	! !

!OBAncestryTest methodsFor: 'tests' stamp: 'dvf 8/31/2005 13:17'!
testClassIdentity
	self assert: BogusA asNode isAncestorOf: BogusA asNode! !

!OBAncestryTest methodsFor: 'tests' stamp: 'dvf 8/31/2005 13:17'!
testClassInClassCategory
	| cat |
	cat := OBClassCategoryNode on: 'Bogus-Base' inEnvironment: Smalltalk.
	self assert: cat isAncestorOf: BogusA asNode! !

!OBAncestryTest methodsFor: 'tests' stamp: 'dvf 8/31/2005 13:17'!
testClassInOtherCategory
	| cat |
	cat := OBClassCategoryNode on: 'Bogus-Base' inEnvironment: Smalltalk.
	self deny: cat isAncestorOf: BogusF asNode! !

!OBAncestryTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 12:55'!
testClassMethodInClassCat
	self 
		assert: (OBClassCategoryNode on: #'Bogus-Base' inEnvironment: Smalltalk)
		isAncestorOf: (OBMethodNode on: #a inClass: BogusA class)
! !

!OBAncestryTest methodsFor: 'tests' stamp: 'dvf 8/31/2005 13:17'!
testClassOther
	self deny: BogusB asNode isAncestorOf: BogusA asNode! !

!OBAncestryTest methodsFor: 'tests' stamp: 'cwp 9/24/2005 22:28'!
testClassVarInClass
	self 
		assert: BogusB asNode
		isAncestorOf: (OBInstanceVariableNode 
						on: 'FirstClassVariableB' 
						inClass: BogusB)! !

!OBAncestryTest methodsFor: 'tests' stamp: 'cwp 9/24/2005 22:27'!
testInstVarInClass
	self 
		assert: BogusB asNode
		isAncestorOf: (OBInstanceVariableNode 
						on: 'firstInstanceVariableB' 
						inClass: BogusB)! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testMethodCatIdentity
	self 
		assert: (OBMethodCategoryNode on: #letters inClass: BogusA)
		isAncestorOf: (OBMethodCategoryNode on: #letters inClass: BogusA)! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testMethodCatOther
	self 
		deny: (OBMethodCategoryNode on: #numbers inClass: BogusA)
		isAncestorOf: (OBMethodCategoryNode on: #letters inClass: BogusA)! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testMethodIdentity
	self 
		assert: (OBMethodNode on: #a inClass: BogusA)
		isAncestorOf: (OBMethodNode on: #a inClass: BogusA)! !

!OBAncestryTest methodsFor: 'tests' stamp: 'dvf 8/31/2005 13:17'!
testMethodInClass
	self assert: BogusA asNode
		isAncestorOf: (OBMethodNode on: #a inClass: BogusA)! !

!OBAncestryTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 12:54'!
testMethodInClassCat
	self 
		assert: (OBClassCategoryNode on: #'Bogus-Base' inEnvironment: Smalltalk)
		isAncestorOf: (OBMethodNode on: #a inClass: BogusA)
! !

!OBAncestryTest methodsFor: 'tests' stamp: 'dvf 8/31/2005 13:17'!
testMethodInMetaclass
	self deny: BogusA asNode
		isAncestorOf: (OBMethodNode on: #a inClass: BogusA class)! !

!OBAncestryTest methodsFor: 'tests' stamp: ''!
testMethodInMethodCat
	self 
		assert: (OBMethodCategoryNode on: #letters inClass: BogusA)
		isAncestorOf: (OBMethodNode on: #a inClass: BogusA)! !

!OBAncestryTest methodsFor: 'tests' stamp: 'dvf 8/31/2005 13:17'!
testMethodInOtherClass
	self deny: BogusA asNode
		isAncestorOf: (OBMethodNode on: #isString inClass: BogusE)! !

!OBAncestryTest methodsFor: 'tests' stamp: 'cwp 12/8/2004 21:48'!
testMethodOverride
	self 
		assert: (OBMethodNode on: #isString inClass: BogusA)
		isAncestorOf: (OBMethodNode on: #isString inClass: BogusE).
	! !

!OBAncestryTest methodsFor: 'tests' stamp: 'cwp 2/28/2006 17:32'!
testMethodSiblings
	self 
		deny: (OBMethodNode on: #isString inClass: String)
		isAncestorOf: (OBMethodNode on: #isString inClass: BogusA).
	! !

TestCase subclass: #OBClassDefinitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBClassDefinitionTest commentStamp: 'cwp 2/28/2005 23:31' prior: 0!
Right now, OBClassDefinition is mostly covered by the browser tests. Eventually those tests should be moved here,!

!OBClassDefinitionTest methodsFor: 'tests' stamp: 'cwp 2/28/2005 23:33'!
testDoItReceiverClass
	| definition |
	definition _ OBClassDefinition environment: Smalltalk template: BogusA definition.
	self deny: definition doItReceiver isMeta.
	! !

TestCase subclass: #OBClassHierarchyTest
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBClassHierarchyTest methodsFor: 'constants' stamp: 'cwp 12/11/2004 00:13'!
bogusA
	^ self nodeForClassNamed: #BogusA! !

!OBClassHierarchyTest methodsFor: 'constants' stamp: 'cwp 12/11/2004 00:13'!
bogusB
	^ self nodeForClassNamed: #BogusB! !

!OBClassHierarchyTest methodsFor: 'constants' stamp: 'cwp 12/11/2004 00:29'!
bogusE
	^ self nodeForClassNamed: #BogusE! !

!OBClassHierarchyTest methodsFor: 'constants' stamp: 'cwp 12/11/2004 00:12'!
nodeForClassNamed: aSymbol
	^ classes detect: [:ea | ea theClassName = aSymbol]! !

!OBClassHierarchyTest methodsFor: 'running' stamp: 'cwp 12/12/2004 22:24'!
setUp
	| metacat cat |
	metacat := OBMetaNode new childAt: #classesHierarchically
				put: (OBMetaNode new displaySelector: #name).
	cat := OBClassCategoryNode on: BogusInfo baseCategory
				inEnvironment: BogusInfo environment.
	classes := metacat nodesForParent: cat! !

!OBClassHierarchyTest methodsFor: 'tests' stamp: 'cwp 12/11/2004 00:11'!
testAB
	self assert: (classes indexOf: self bogusA) < (classes indexOf: self bogusB)! !

!OBClassHierarchyTest methodsFor: 'tests' stamp: 'cwp 12/11/2004 00:33'!
testAE
	self assert: (classes indexOf: self bogusA) < (classes indexOf: self bogusE)! !

!OBClassHierarchyTest methodsFor: 'tests' stamp: 'cwp 12/11/2004 00:29'!
testEB
	self assert: (classes indexOf: self bogusE) < (classes indexOf: self bogusB)! !

TestCase subclass: #OBCodeBrowserUiTest
	instanceVariableNames: 'browser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCodeBrowserUiTest methodsFor: 'running' stamp: 'cwp 12/6/2004 22:11'!
setUp
	browser _ OBSystemBrowser new.
	browser addDependent: self.
	! !

!OBCodeBrowserUiTest methodsFor: 'running' stamp: 'cwp 12/6/2004 22:11'!
tearDown
	browser removeDependent: self! !

!OBCodeBrowserUiTest methodsFor: 'tests' stamp: 'cwp 6/3/2006 19:41'!
testWindowMenu
	| menu |
	(Smalltalk includesKey: #SystemBrowser) ifFalse: [^ self].
	menu _ MenuMorph new.
	browser addModelItemsToWindowMenu: menu.
	self deny: (menu itemWithWording: 'Register this Browser as default') isNil.
	self deny: (menu itemWithWording: 'Choose new default browser') isNil
		! !

TestCase subclass: #OBCodeNodeEqualityTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCodeNodeEqualityTest methodsFor: 'tests' stamp: 'cwp 12/20/2004 00:47'!
testClassCategoryEquality
	self assert: (OBClassCategoryNode on: #'Bogus-Base' inEnvironment: Smalltalk)
					=  (OBClassCategoryNode on: #'Bogus-Base' inEnvironment: Smalltalk)! !

!OBCodeNodeEqualityTest methodsFor: 'tests' stamp: 'cwp 12/20/2004 00:48'!
testClassCategoryInequality
	self deny: (OBClassCategoryNode on: #'Bogus-Base' inEnvironment: Smalltalk)
					=  (OBClassCategoryNode on: #'Bogus-Formats' inEnvironment: Smalltalk)! !

!OBCodeNodeEqualityTest methodsFor: 'tests' stamp: 'cwp 12/20/2004 22:21'!
testClassCommentEquality
	self assert: (OBClassCommentNode on: BogusA)
					= (OBClassCommentNode on: BogusA)! !

!OBCodeNodeEqualityTest methodsFor: 'tests' stamp: 'cwp 12/20/2004 22:23'!
testClassCommentInequality
	self deny: (OBClassCommentNode on: BogusA)
					= (OBClassCommentNode on: BogusB)! !

!OBCodeNodeEqualityTest methodsFor: 'tests' stamp: 'dvf 8/31/2005 13:14'!
testClassEquality
	self assert: BogusA asNode = BogusA asNode! !

!OBCodeNodeEqualityTest methodsFor: 'tests' stamp: 'dvf 8/31/2005 13:17'!
testClassInequality
	self deny: BogusA asNode = BogusB asNode! !

!OBCodeNodeEqualityTest methodsFor: 'tests' stamp: 'cwp 12/20/2004 00:39'!
testMethod
	self assert: (OBMethodNode on: #one inClass: BogusA)
					= (OBMethodNode on: #one inClass: BogusA)! !

!OBCodeNodeEqualityTest methodsFor: 'tests' stamp: 'cwp 12/20/2004 00:46'!
testMethodCategoryEquality
	self assert: (OBMethodCategoryNode on: #numbers inClass: BogusA)
					= (OBMethodCategoryNode on: #numbers inClass: BogusA)! !

!OBCodeNodeEqualityTest methodsFor: 'tests' stamp: 'cwp 12/20/2004 00:46'!
testMethodCategoryInequality1
	self deny: (OBMethodCategoryNode on: #numbers inClass: BogusA)
					= (OBMethodCategoryNode on: #letters inClass: BogusA)! !

!OBCodeNodeEqualityTest methodsFor: 'tests' stamp: 'cwp 12/20/2004 00:47'!
testMethodCategoryInequality2
	self deny: (OBMethodCategoryNode on: #numbers inClass: BogusA)
					= (OBMethodCategoryNode on: #numbers inClass: BogusB)! !

!OBCodeNodeEqualityTest methodsFor: 'tests' stamp: 'cwp 12/20/2004 00:45'!
testMethodEquality
	self assert: (OBMethodNode on: #one inClass: BogusA)
					= (OBMethodNode on: #one inClass: BogusA)! !

!OBCodeNodeEqualityTest methodsFor: 'tests' stamp: 'cwp 12/20/2004 00:45'!
testMethodInequality1
	self deny: (OBMethodNode on: #one inClass: BogusA)
					= (OBMethodNode on: #two inClass: BogusA)! !

!OBCodeNodeEqualityTest methodsFor: 'tests' stamp: 'cwp 12/20/2004 00:46'!
testMethodInequality2
	self deny: (OBMethodNode on: #one inClass: BogusA)
					= (OBMethodNode on: #one inClass: BogusB)! !

TestCase subclass: #OBCodeSanityCheckTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCodeSanityCheckTest methodsFor: 'constants' stamp: ''!
bogusARedefinition
	^ BogusA definition! !

!OBCodeSanityCheckTest methodsFor: 'constants' stamp: ''!
bogusCDefinition
	^ 'Object subclass: #BogusC
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', BogusInfo baseCategory, ''''! !

!OBCodeSanityCheckTest methodsFor: 'callbacks' stamp: ''!
selectionInterval
	^ 1 to: 0! !

!OBCodeSanityCheckTest methodsFor: 'testing' stamp: ''!
testClassCreation
	node := OBClassCategoryNode on: BogusInfo baseCategory inEnvironment: Smalltalk.
	self 
		should: [node definition accept: self bogusCDefinition notifying: self]
		raise: OBConfirmationRequest! !

!OBCodeSanityCheckTest methodsFor: 'testing' stamp: 'dvf 8/31/2005 13:17'!
testClassDefinition
	node := BogusA asNode.
	self 
		should: [node definition accept: self bogusCDefinition notifying: self]
		raise: OBConfirmationRequest! !

!OBCodeSanityCheckTest methodsFor: 'testing' stamp: 'dvf 8/31/2005 13:17'!
testClassRedefinition
	node := BogusA asNode.
	self shouldnt: [node accept: self bogusARedefinition notifying: self]
		raise: OBConfirmationRequest! !

!OBCodeSanityCheckTest methodsFor: 'callbacks' stamp: ''!
text
	^ node text asText! !

TestCase subclass: #OBCommandTest
	instanceVariableNames: 'service'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

OBCommandTest subclass: #OBCategoryCommandTest
	instanceVariableNames: 'announcer organizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCategoryCommandTest class methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:13'!
isAbstract
	^ self name == #OBCategoryCommandTest! !

!OBCategoryCommandTest methodsFor: 'emulating' stamp: 'cwp 9/28/2006 09:15'!
announce: anObject
	^ announcer announce: anObject! !

!OBCategoryCommandTest methodsFor: 'accessing' stamp: 'cwp 9/28/2006 09:17'!
announcer
	^ announcer! !

!OBCategoryCommandTest methodsFor: 'emulating' stamp: 'cwp 10/9/2006 16:10'!
isSelected: aNode
	^ false! !

!OBCategoryCommandTest methodsFor: 'emulating' stamp: 'cwp 6/25/2006 17:38'!
organization
	^ organizer! !

!OBCategoryCommandTest methodsFor: 'emulating' stamp: 'cwp 6/28/2006 00:40'!
requestor
	^ OBRequestor for: self! !

!OBCategoryCommandTest methodsFor: 'running' stamp: 'cwp 6/29/2006 00:45'!
setUp
	announcer _ OBAnnouncer new.
	organizer _ SystemOrganizer defaultList: #().
! !

OBCategoryCommandTest subclass: #OBCmdAutoCategorizeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdAutoCategorizeTest methodsFor: 'running' stamp: 'cwp 11/2/2006 00:19'!
factory
	^OBCmdAutoCategorize! !

!OBCmdAutoCategorizeTest methodsFor: 'tests' stamp: 'cwp 9/25/2006 00:26'!
test04ConditionRejectsClassCatNode
	| node |
	node _ OBClassCategoryNode 
			on: 'Foo' 
			inEnvironment: self.
	self deny: (self isActiveOn: node for: self)! !

!OBCmdAutoCategorizeTest methodsFor: 'tests' stamp: 'cwp 9/25/2006 00:28'!
test05ConditionRejectsMethodCatNode

	| node |
	node _ OBMethodCategoryNode on: 'tests' inClass: self class.
	self deny: (self isActiveOn: node for: self)! !

!OBCmdAutoCategorizeTest methodsFor: 'tests' stamp: 'cwp 9/25/2006 00:30'!
test06ConditionRejectsEnvironmentNode

	| node |
	node _ OBEnvironmentNode on: self.
	self deny: (self isActiveOn: node for: self)! !

!OBCmdAutoCategorizeTest methodsFor: 'tests' stamp: 'cwp 9/25/2006 00:31'!
test07ConditionAcceptsClassNode

	| node |
	node _ OBClassNode on: self class.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdAutoCategorizeTest methodsFor: 'tests' stamp: 'cwp 10/15/2006 16:20'!
test09Execution
	"Just execute the code to ensure there's nothing horribly
	wrong. Trying to assert that it classifies methods correctly
	would be a pain."

	| node |
	node _ OBClassNode on: self class.
	self executeOn: node for: self.
		
		! !

OBCategoryCommandTest subclass: #OBCmdCreateCatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdCreateCatTest methodsFor: 'support' stamp: 'cwp 11/2/2006 00:22'!
factory
	^OBCmdCreateCategory! !

!OBCmdCreateCatTest methodsFor: 'tests' stamp: 'cwp 9/25/2006 00:05'!
test04ConditionRejectsClassCatNode
	| node |
	node _ OBClassCategoryNode 
			on: 'Foo' 
			inEnvironment: self.
	self deny: (self isActiveOn: node for: self)! !

!OBCmdCreateCatTest methodsFor: 'tests' stamp: 'cwp 9/25/2006 00:06'!
test05ConditionRejectsMethodCatNode

	| node |
	node _ OBMethodCategoryNode on: 'tests' inClass: self class.
	self deny: (self isActiveOn: node for: self)! !

!OBCmdCreateCatTest methodsFor: 'tests' stamp: 'cwp 9/25/2006 00:30'!
test06ConditionAcceptsEnvironmentNode

	| node |
	node _ OBEnvironmentNode on: self.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdCreateCatTest methodsFor: 'tests' stamp: 'cwp 9/25/2006 00:06'!
test07ConditionAcceptsClassNode

	| node |
	node _ OBClassNode on: self class.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdCreateCatTest methodsFor: 'tests' stamp: 'cwp 10/15/2006 16:43'!
test08ExecutionOnEnvironmentNode
	| node |
	node _ OBEnvironmentNode on: self.
	[self executeOn: node for: self] on: OBTextRequest
		do: 
			[:n | 
			self assert: n template = 'Category-Name'.
			n resume: 'Test-Category'].
	self assert: (organizer categories includes: 'Test-Category')! !

!OBCmdCreateCatTest methodsFor: 'tests' stamp: 'cwp 10/15/2006 16:45'!
test09ExecutionOnClassNode
	| node |
	node _ OBClassNode on: self.
	[self executeOn: node for: self] 
		on: OBTextRequest
		do: 
			[:n | 
			self assert: n template = 'Category-Name'.
			n resume: 'Test-Category'].
	self assert: (organizer categories includes: 'Test-Category')! !

OBCategoryCommandTest subclass: #OBCmdRemoveCatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdRemoveCatTest methodsFor: 'running' stamp: 'cwp 11/2/2006 00:23'!
factory
	^OBCmdRemoveCat! !

!OBCmdRemoveCatTest methodsFor: 'emulating' stamp: 'cwp 10/9/2006 16:11'!
isSelected: aNode
	^ true! !

!OBCmdRemoveCatTest methodsFor: 'emulating' stamp: 'cwp 7/17/2006 13:50'!
removeCategory: aSymbol 
	organizer removeCategory: aSymbol! !

!OBCmdRemoveCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:36'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $x.! !

!OBCmdRemoveCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:39'!
test04ConditionAcceptsClassCatNode
	| node |
	node _ OBClassCategoryNode 
			on: 'Foo' 
			inEnvironment: self.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdRemoveCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:40'!
test05ConditionAcceptsMethodCatNode

	| node |
	node _ OBMethodCategoryNode on: 'tests' inClass: self class.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdRemoveCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:41'!
test06ConditionRejectsEnvironmentNode

	| node |
	node _ OBEnvironmentNode on: organizer.
	self deny: (self isActiveOn: node for: self)! !

!OBCmdRemoveCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:41'!
test07ConditionRejectsClassNode

	| node |
	node _ OBClassNode on: self class.
	self deny: (self isActiveOn: node for: self)! !

!OBCmdRemoveCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:42'!
test08ExecutionOnClassCatNode
	| node |
	organizer _ SystemOrganizer defaultList: #().
	organizer addCategory: 'Some-Category'.
	node _ OBClassCategoryNode 
			on: 'Some-Category' 
			inEnvironment: self.
	self executeOn: node for: self.
	self deny: (organizer categories includes: 'Some-Category')! !

!OBCmdRemoveCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:43'!
test09ExecutionOnMethodCatNode
	| node |
	organizer _ ClassOrganizer defaultList: #().
	organizer addCategory: #category.
	node _ OBMethodCategoryNode
			on: #category 
			inClass: self.
	self executeOn: node for: self.
	self deny: (organizer categories includes: #category)! !

OBCategoryCommandTest subclass: #OBCmdRemoveEmptyCatsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdRemoveEmptyCatsTest methodsFor: 'support' stamp: 'cwp 11/2/2006 00:23'!
factory
	^OBCmdRemoveEmptyCats! !

!OBCmdRemoveEmptyCatsTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:49'!
test04ConditionRejectsClassCatNode
	| node |
	node _ OBClassCategoryNode 
				on: 'Foo' 
				inEnvironment: self.
	self deny: (self isActiveOn: node for: self).! !

!OBCmdRemoveEmptyCatsTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:49'!
test05ConditionRejectsMethodCatNode

	| node |
	node _ OBMethodCategoryNode on: 'tests' inClass: self class.
	self deny: (self isActiveOn: node for: self)! !

!OBCmdRemoveEmptyCatsTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:50'!
test06ConditionAcceptsEnvironmentNode

	| node |
	node _ OBEnvironmentNode on: self.
	self assert: (self isActiveOn: node for: self).! !

!OBCmdRemoveEmptyCatsTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:50'!
test07ConditionAcceptsClassNode

	| node |
	node _ OBClassNode on: self class.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdRemoveEmptyCatsTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:51'!
test08ExecutionOnEnvironmentNode
	| node |
	organizer _ SystemOrganizer defaultList: #().
	organizer addCategory: 'Empty'.
	organizer classify: #'not-a-class-name' under: 'NotEmpty'.
	node _ OBEnvironmentNode on: self.
	self executeOn: node for: self.
	self deny: (organizer categories includes: 'Empty').
	self assert: (organizer categories includes: 'NotEmpty').! !

!OBCmdRemoveEmptyCatsTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:51'!
test09ExecutionOnClassNode
	| node |
	organizer _ ClassOrganizer defaultList: #().
	organizer addCategory: 'Empty'.
	organizer classify: #'not-a-selector' under: 'NotEmpty'.
	node _ OBClassNode on: self.
	self executeOn: node for: self.
	self deny: (organizer categories includes: 'Empty').
	self assert: (organizer categories includes: 'NotEmpty').! !

OBCategoryCommandTest subclass: #OBCmdRenameCatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdRenameCatTest methodsFor: 'running' stamp: 'cwp 11/2/2006 00:23'!
factory
	^OBCmdRenameCat! !

!OBCmdRenameCatTest methodsFor: 'emulating' stamp: 'cwp 10/9/2006 16:12'!
isSelected: aNode
	^ true! !

!OBCmdRenameCatTest methodsFor: 'emulating' stamp: 'cwp 7/25/2006 17:54'!
removeCategory: aSymbol 
	organizer removeCategory: aSymbol! !

!OBCmdRenameCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:57'!
test04ConditionAcceptsClassCatNode
	| node |
	node _ OBClassCategoryNode 
			on: 'Foo' 
			inEnvironment: self.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdRenameCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:58'!
test05ConditionAcceptsMethodCatNode

	| node |
	node _ OBMethodCategoryNode on: 'tests' inClass: self class.
	self assert: (self isActiveOn: node for: self).! !

!OBCmdRenameCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:58'!
test06ConditionRejectsEnvironmentNode

	| node |
	node _ OBEnvironmentNode on: self.
	self deny: (self isActiveOn: node for: self)! !

!OBCmdRenameCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 08:59'!
test07ConditionRejectsClassNode

	| node |
	node _ OBClassNode on: self class.
	self deny: (self isActiveOn: node for: self).! !

!OBCmdRenameCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 09:00'!
test08ExecutionOnClassCatNode
	| node |
	organizer _ SystemOrganizer defaultList: #().
	organizer addCategory: 'Some-Category'.
	node _ OBClassCategoryNode 
				on: 'Some-Category' 
				inEnvironment: self.
	[self executeOn: node for: self] 
		on: OBTextRequest
		do: [:n | 
			self assert: n template = 'Some-Category'.
			n resume: 'Test-Category'].
	self deny: (organizer categories includes: 'Some-Category').
	self assert: (organizer categories includes: 'Test-Category')! !

!OBCmdRenameCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 09:00'!
test09ExecutionOnMethodCatNode
	| node |
	organizer _ ClassOrganizer defaultList: #().
	organizer addCategory: #category.
	node _ OBMethodCategoryNode
			on: #category 
			inClass: self.
	[self executeOn: node for: self] 
		on: OBTextRequest
		do: [:n | 
			self assert: n template = 'category'.
			n resume: #'new name'].
	self deny: (organizer categories includes: #category).
	self assert: (organizer categories includes: #'new name').! !

OBCategoryCommandTest subclass: #OBCmdReorgCatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdReorgCatTest methodsFor: 'support' stamp: 'cwp 11/2/2006 00:23'!
factory
	^OBCmdReorgCats! !

!OBCmdReorgCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 09:09'!
test04ConditionRejectsClassCatNode
	| node |
	node _ OBClassCategoryNode 
				on: 'Foo' 
				inEnvironment: organizer.
	self deny: (self isActiveOn: node for: self)! !

!OBCmdReorgCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 09:09'!
test05ConditionRejectsMethodCatNode

	| node |
	node _ OBMethodCategoryNode on: 'tests' inClass: self class.
	self deny: (self isActiveOn: node for: self).! !

!OBCmdReorgCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 09:10'!
test06ConditionAcceptsEnvironmentNode

	| node |
	node _ OBEnvironmentNode on: self.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdReorgCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 09:10'!
test07ConditionAcceptsClassNode

	| node |
	node _ OBClassNode on: self class.
	self assert: (self isActiveOn: node for: self).! !

!OBCmdReorgCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 09:11'!
test08ExecutionOnEnvironmentNode
	| ann node |
	ann _ nil.
	self announcer 
		observe: OBDefinitionChanged 
		do: [:obj | ann _ obj].
	node _ OBEnvironmentNode on: self.
	self executeOn: node for: self.
	self deny: ann isNil! !

!OBCmdReorgCatTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 09:11'!
test09ExecutionOnClassNode
	| ann node |
	ann _ nil.
	self announcer 
		observe: OBDefinitionChanged 
		do: [:obj | ann _ obj].
	node _ OBClassNode on: self.
	self executeOn: node for: self.
	self deny: ann isNil! !

OBCategoryCommandTest subclass: #OBCmdSortCatsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdSortCatsTest methodsFor: 'running' stamp: 'cwp 11/2/2006 00:23'!
factory
	^OBCmdSortCats! !

!OBCmdSortCatsTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 09:21'!
test04ConditionRejectsClassCatNode
	
	| node |
	node _ OBClassCategoryNode 
			on: 'Foo' 
			inEnvironment: self.
	self deny: (self isActiveOn: node for: self)! !

!OBCmdSortCatsTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 09:22'!
test05ConditionRejectsMethodCatNode

	| node |
	node _ OBMethodCategoryNode on: 'tests' inClass: self class.
	self deny: (self isActiveOn: node for: self).! !

!OBCmdSortCatsTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 09:22'!
test06ConditionAcceptsEnvironmentNode

	| node |
	node _ OBEnvironmentNode on: self.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdSortCatsTest methodsFor: 'tests' stamp: 'cwp 9/28/2006 09:23'!
test07ConditionAcceptsClassNode

	| node |
	node _ OBClassNode on: self class.
	self assert: (self isActiveOn: node for: self).! !

!OBCmdSortCatsTest methodsFor: 'tests' stamp: 'cwp 10/15/2006 18:38'!
test08ExecutionOnEnvironmentNode
	| node |
	organizer _ SystemOrganizer defaultList: #().
	organizer addCategory: 'Bravo'.
	organizer addCategory: 'Alpha'.
	organizer addCategory: 'Delta'.
	self deny: (organizer categories = #(Bravo Bravo Delta)).
	node _ OBEnvironmentNode on: self.
	self executeOn: node for: self.
	self assert: (organizer categories = #(Alpha Bravo Delta)).! !

!OBCmdSortCatsTest methodsFor: 'tests' stamp: 'cwp 10/15/2006 18:42'!
test09ExecutionOnClassNode
	| node |
	organizer _ ClassOrganizer defaultList: #().
	organizer 
		addCategory: 'bravo';
		addCategory: 'alpha';
		addCategory: 'delta'.
	self deny: organizer categories = #(alpha bravo delta).
	node _ OBClassNode on: self.
	self executeOn: node for: self.
	self assert: organizer categories = #(alpha bravo delta).! !

OBCommandTest subclass: #OBCmdBrowseHierarchyTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdBrowseHierarchyTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:21'!
factory
	^OBCmdBrowseHierarchy! !

!OBCmdBrowseHierarchyTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/11/2006 00:07'!
isSelected: aNode
	^ isSelected ifNil: [false]! !

!OBCmdBrowseHierarchyTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2007 19:47'!
test03DoesntWantButton
	self assert: self command wantsButton! !

!OBCmdBrowseHierarchyTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/11/2006 00:06'!
test04ConditionAcceptsClass
	| node |
	node _ OBClassNode on: self class.
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdBrowseHierarchyTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/11/2006 00:08'!
test05ConditionIgnoresParentNode
	| node |
	node _ OBClassNode on: self class.
	isSelected _ false.
	self deny: (self isActiveOn: node for: self).
	! !

!OBCmdBrowseHierarchyTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/11/2006 00:11'!
test06OpensHierarchyBrowser
	| node browser |
	node _ OBClassNode on: self class.
	[self executeOn: node for: self]
		on: OBBrowseRequest 
		do: [:req | browser _ req browser].
	self assert: (browser isKindOf: OBHierarchyBrowser).
	self assert: (browser root = node)! !

OBCommandTest subclass: #OBCmdBrowseMethodVersionsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdBrowseMethodVersionsTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:22'!
factory
	^OBCmdBrowseMethodVersions! !

!OBCmdBrowseMethodVersionsTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/9/2006 18:20'!
isSelected: aNode
	^ true! !

!OBCmdBrowseMethodVersionsTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/9/2006 17:59'!
test02HasCorrectKeystroke 
	self assert: self command keystroke = $v! !

!OBCmdBrowseMethodVersionsTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2007 19:50'!
test03DoesntWantButton
	self assert: self command wantsButton! !

!OBCmdBrowseMethodVersionsTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/9/2006 18:00'!
test04ConditionAcceptsMethod
	| node |
	node _ OBMethodNode on: #setUp inClass: self class.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdBrowseMethodVersionsTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/15/2006 20:52'!
test05OpensVersionsBrowser
	| node browser |
	node _ OBMethodNode on: #test05OpensVersionsBrowser inClass: self class.
	[self executeOn: node for: self]
		on: OBBrowseRequest 
		do: [:req | browser _ req browser].
	self assert: (browser isKindOf: OBVersionBrowser).
	self assert: (browser root = node)! !

OBCommandTest subclass: #OBCmdBrowseReferencesTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdBrowseReferencesTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/7/2006 21:40'!
factory
	^ OBCmdBrowseReferences! !

!OBCmdBrowseReferencesTest methodsFor: 'testing' stamp: 'cwp 12/7/2006 21:53'!
isSelected: anObject
	^ isSelected! !

!OBCmdBrowseReferencesTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/7/2006 21:45'!
test04ConditionAcceptsClass
	| node |
	node _ OBClassNode on: self class.
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdBrowseReferencesTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/7/2006 21:48'!
test05ConditionIgnoresParentNode
	| node |
	node _ OBClassNode on: self class.
	isSelected _ false.
	self deny: (self isActiveOn: node for: self).
	! !

!OBCmdBrowseReferencesTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/7/2006 22:13'!
test06OpensBrowserOnClass
	| node browser |
	node _ OBClassNode on: self class.
	[self executeOn: node for: self]
		on: OBBrowseRequest
		do: [:req | browser _ req browser].
	self assert: (browser isKindOf: OBReferencesBrowser).
	self assert: browser currentOrRootNode = node.! !

!OBCmdBrowseReferencesTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/7/2006 22:30'!
test07BelongsToNavigationGroup
	self assert: self command group = #navigation! !

OBCommandTest subclass: #OBCmdBrowseTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdBrowseTest methodsFor: 'support' stamp: 'cwp 10/9/2006 15:33'!
assertOpensOn: node
	| target |
	[self executeOn: node for: self]
		on: OBBrowseRequest
		do: [:req | target _ req browser currentOrRootNode].
	self assert: target = node! !

!OBCmdBrowseTest methodsFor: 'support' stamp: 'cwp 11/2/2006 00:22'!
factory
	^OBCmdBrowse! !

!OBCmdBrowseTest methodsFor: 'testing' stamp: 'cwp 10/9/2006 15:42'!
isSelected: aNode 
	^ true! !

!OBCmdBrowseTest methodsFor: 'tests' stamp: 'cwp 10/9/2006 15:18'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $b! !

!OBCmdBrowseTest methodsFor: 'tests' stamp: 'cwp 3/11/2007 19:46'!
test03DoesntWantButton
	self assert: self command wantsButton! !

!OBCmdBrowseTest methodsFor: 'tests' stamp: 'cwp 10/9/2006 15:20'!
test04ConditionAcceptsClassCategory
	| node |
	node _ OBClassCategoryNode on: self class category inEnvironment: self class environment.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdBrowseTest methodsFor: 'tests' stamp: 'cwp 10/9/2006 15:22'!
test05ConditionAcceptsClass
	| node |
	node _ OBClassNode on: self class.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdBrowseTest methodsFor: 'tests' stamp: 'cwp 10/9/2006 15:22'!
test06ConditionAcceptsMethodCategory
	| node |
	node _ OBMethodCategoryNode on: 'tests' inClass: self class.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdBrowseTest methodsFor: 'tests' stamp: 'cwp 10/9/2006 15:26'!
test07ConditionAcceptsMethod
	| node |
	node _ OBMethodNode on: #setUp inClass: self class.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdBrowseTest methodsFor: 'tests' stamp: 'cwp 10/9/2006 15:34'!
test08OpensBrowserOnClassCategory
	self assertOpensOn: 	(OBClassCategoryNode 
							on: self class category 
							inEnvironment: self class environment)! !

!OBCmdBrowseTest methodsFor: 'tests' stamp: 'cwp 10/9/2006 15:33'!
test09OpensBrowserOnClass
	self assertOpensOn: 	(OBClassNode on: self class)! !

!OBCmdBrowseTest methodsFor: 'tests' stamp: 'cwp 10/9/2006 15:36'!
test10OpensBrowserOnMethodCategory
	self assertOpensOn: 	(OBMethodCategoryNode on: 'tests' inClass: self class)! !

!OBCmdBrowseTest methodsFor: 'tests' stamp: 'cwp 10/15/2006 21:04'!
test11OpensBrowserOnMethod
	self assertOpensOn: 	(OBMethodNode 
							on: #test11OpensBrowserOnMethod 
							inClass: self class)! !

OBCommandTest subclass: #OBCmdChaseVarabiesTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdChaseVarabiesTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:22'!
factory
	^OBCmdChaseVariables! !

!OBCmdChaseVarabiesTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/10/2006 22:34'!
isSelected: aNode
	^ isSelected! !

!OBCmdChaseVarabiesTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2007 19:47'!
test03DoesntWantButton
	self assert: self command wantsButton! !

!OBCmdChaseVarabiesTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/10/2006 22:33'!
test04ConditionAcceptsClass
	| node |
	node _ OBClassNode on: self class.
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdChaseVarabiesTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/10/2006 22:33'!
test05ConditionIgnoresParentNode
	| node |
	node _ OBClassNode on: self class.
	isSelected _ false.
	self deny: (self isActiveOn: node for: self).
	! !

!OBCmdChaseVarabiesTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/10/2006 22:45'!
test06ExecutionOpensBrowser
	| node browser |
	node _ OBClassNode on: self class.
	[self executeOn: node for: self]
		on: OBBrowseRequest
		do: [:req | browser _ req browser].
	self assert: (browser root = node)! !

OBCommandTest subclass: #OBCmdClassTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdClassTest class methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 22:40'!
isAbstract
	^ self name = #OBCmdClassTest! !

!OBCmdClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 22:43'!
isSelected: anObject
	^ isSelected! !

!OBCmdClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 22:43'!
test04ConditionAcceptsClass
	| node |
	isSelected _ true.
	node _ OBClassNode on: self class.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 22:43'!
test05ConditionRequiresSelection
	| node |
	isSelected _ false.
	node _ OBClassNode on: self class.
	self deny: (self isActiveOn: node for: self)! !

OBCmdClassTest subclass: #OBCmdCopyClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdCopyClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 20:05'!
factory
	^ OBCmdCopyClass! !

OBCmdClassTest subclass: #OBCmdRemoveClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdRemoveClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/3/2006 00:10'!
factory
	^ OBCmdRemoveClass! !

!OBCmdRemoveClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/3/2006 00:17'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $x! !

OBCmdClassTest subclass: #OBCmdRenameClassTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdRenameClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 22:46'!
factory
	^ OBCmdRenameClass! !

OBCommandTest subclass: #OBCmdFileOutTest
	instanceVariableNames: 'fileOutSent isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdFileOutTest methodsFor: 'support' stamp: 'cwp 11/2/2006 00:22'!
factory
	^OBCmdFileOut! !

!OBCmdFileOutTest methodsFor: 'support' stamp: 'cwp 10/7/2006 11:22'!
fileOut
	fileOutSent _ true! !

!OBCmdFileOutTest methodsFor: 'testing' stamp: 'cwp 10/9/2006 16:11'!
isSelected: aNode
	^ isSelected ifNil: [true]! !

!OBCmdFileOutTest methodsFor: 'support' stamp: 'cwp 10/7/2006 11:29'!
selectedNode
	^ nil! !

!OBCmdFileOutTest methodsFor: 'tests' stamp: 'cwp 10/9/2006 16:09'!
test04ConditionTestsForFileOutMethod
	| node |
	node _ Object new.
	self deny: (self isActiveOn: node for: self)! !

!OBCmdFileOutTest methodsFor: 'tests' stamp: 'cwp 10/7/2006 11:31'!
test05ActionSendsFileOut
	self executeOn: self for: self.
	self assert: fileOutSent! !

!OBCmdFileOutTest methodsFor: 'tests' stamp: 'cwp 10/9/2006 16:11'!
test06ConditionRejectsParentNode
	isSelected _ false.
	self deny: (self isActiveOn: self for: self)! !

OBCommandTest subclass: #OBCmdFindClassTest
	instanceVariableNames: 'found'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdFindClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/9/2006 14:28'!
announcer
	| announcer |
	announcer _ OBAnnouncer new.
	announcer observe: OBSelectingNode do: [:ann | found _ ann node theClass].
	^ announcer! !

!OBCmdFindClassTest methodsFor: 'emulating' stamp: 'cwp 10/9/2006 17:10'!
classNames
	^ #('BravoCharlie' 'AlphaBravoCharlie' 'Bravo' 'AlphaCharlie')! !

!OBCmdFindClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:22'!
factory
	^OBCmdFindClass! !

!OBCmdFindClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/9/2006 13:38'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $f.! !

!OBCmdFindClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/9/2006 13:37'!
test04ConditionAcceptsEnvironmentNode
	| node |
	node _ OBEnvironmentNode forImage.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdFindClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/9/2006 13:42'!
test05FindsClassFromExactName
	| node |
	node _ OBEnvironmentNode forImage.
	[self executeOn: node for: self]
		on: OBTextRequest
		do: [:req | req resume: self class name asString].
	self assert: (found == self class)! !

!OBCmdFindClassTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/15/2006 20:54'!
test06ExactMatchFirst
	| name labels |
	name _ 'Bravo'.
	[self command findClassIn: self pattern: name]
		on: OBChoiceRequest
		do: [:choice | labels _ choice labels].
	self deny: labels isNil.
	self assert: labels first = name.! !

!OBCmdFindClassTest methodsFor: 'tests' stamp: 'cwp 10/15/2006 20:54'!
test07ExactMatchHasLine
	| name lines |
	name _ 'Bravo'.
	[self command findClassIn: self pattern: name]
		on: OBChoiceRequest
		do: [:choice | lines _ choice lines].
	self deny: lines isNil.
	self assert: lines = #(1)! !

!OBCmdFindClassTest methodsFor: 'emulating' stamp: 'cwp 10/9/2006 17:10'!
traitNames
	^ #()! !

OBCommandTest subclass: #OBCmdFindMethodTest
	instanceVariableNames: 'isSelected handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdFindMethodTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/31/2006 20:51'!
announcer
	^ OBAnnouncer new
		observe: OBAnnouncement do: handler;
		yourself! !

!OBCmdFindMethodTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:23'!
factory
	^OBCmdFindMethod! !

!OBCmdFindMethodTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/16/2006 23:58'!
isSelected: aNode
	^ isSelected! !

!OBCmdFindMethodTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/16/2006 23:58'!
test04ConditionAcceptsClass
	| node |
	isSelected _ true.
	node _ OBClassNode on: self class.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdFindMethodTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/16/2006 23:57'!
test05ConditionTargetToBeSelected
	| node |
	node _ OBClassNode on: self class.
	isSelected _ false.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdFindMethodTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/31/2006 19:45'!
test06ActionFindsExistingSelectors
	| node choice |
	node _ OBClassNode on: self class.
	[self executeOn: node for: self]
		on: OBChoiceRequest
		do: [:req | choice _ req].
	self deny:  choice isNil.
	self assert: (choice labels includesAllOf: self class selectors)! !

!OBCmdFindMethodTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/31/2006 20:54'!
test07ActionOpensBrowser
	| node selector announcement |
	handler _ [:ann | announcement _ ann].
	node _ OBClassNode on: self class.
	[self executeOn: node for: self]
		on: OBChoiceRequest
		do: [:choice | selector _ choice labels first.
			choice select: choice labels first].
	self deny: selector isNil.
	self assert: announcement node selector = selector! !

OBCommandTest subclass: #OBCmdMoveToPackageTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdMoveToPackageTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2006 20:13'!
factory
	^ OBCmdMoveToPackage! !

!OBCmdMoveToPackageTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2006 20:19'!
isSelected: ignored
	^ isSelected! !

!OBCmdMoveToPackageTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2006 21:32'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $p! !

!OBCmdMoveToPackageTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2006 20:17'!
test04ConditionAcceptsMethods
	| node |
	node _ OBMethodNode on: #test04ConditionAcceptsMethods inClass: self class.
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdMoveToPackageTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/11/2006 20:18'!
test05ConditionRequiresSelection
	| node |
	node _ OBMethodNode on: #test04ConditionAcceptsMethods inClass: self class.
	isSelected _ false.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #OBCmdRemoveMethodTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdRemoveMethodTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2006 23:16'!
factory
	^ OBCmdRemoveMethod! !

!OBCmdRemoveMethodTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2006 23:27'!
isSelected: anObject
	^ isSelected! !

!OBCmdRemoveMethodTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2006 23:17'!
test02HasCorrectKeystroke
	self assert: self command keystroke = $x! !

!OBCmdRemoveMethodTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2006 23:25'!
test04ConditionAcceptsMethod
	| node |
	isSelected _ true	.
	node _ OBMethodNode on: #test04ConditionAcceptsMethod inClass: self class.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdRemoveMethodTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/9/2006 20:07'!
test05ConditionRequiresSelection
	| node |
	isSelected _ false.
	node _ OBMethodNode on: #test04ConditionAcceptsMethod inClass: self class.
	self deny: (self isActiveOn: node for: self)! !

OBCommandTest subclass: #OBCmdRevertMethodTest
	instanceVariableNames: 'fileInSent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdRevertMethodTest methodsFor: 'support' stamp: 'cwp 11/2/2006 00:23'!
factory
	^OBCmdRevertMethod! !

!OBCmdRevertMethodTest methodsFor: 'emulating' stamp: 'cwp 10/9/2006 19:13'!
fileIn
	fileInSent _ true! !

!OBCmdRevertMethodTest methodsFor: 'emulating' stamp: 'cwp 10/9/2006 18:33'!
isSelected: aNode
	^ true! !

!OBCmdRevertMethodTest methodsFor: 'tests' stamp: 'cwp 10/9/2006 18:26'!
test02HasCorrectKeystroke 
	self assert: self command keystroke = $r! !

!OBCmdRevertMethodTest methodsFor: 'tests' stamp: 'cwp 10/9/2006 18:27'!
test04ConditionAcceptsMethodVersion
	| node |
	node _ OBMethodVersionNode on: self.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdRevertMethodTest methodsFor: 'tests' stamp: 'cwp 10/9/2006 19:13'!
test05ExecutionSendsFileIn
	| node |
	node _ OBMethodVersionNode on: self.
	self executeOn: node for: self.
	self assert: fileInSent! !

!OBCmdRevertMethodTest methodsFor: 'emulating' stamp: 'cwp 10/9/2006 18:31'!
theClass
	^ self class! !

OBCommandTest subclass: #OBCmdSelectorNodeTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

OBCmdSelectorNodeTest subclass: #OBCmdBrowseImplementorsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdBrowseImplementorsTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/17/2006 21:19'!
expectedBrowser
	^ OBImplementorsBrowser! !

!OBCmdBrowseImplementorsTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:21'!
factory
	^OBCmdBrowseImplementors! !

!OBCmdBrowseImplementorsTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/15/2006 21:14'!
test02HasCorrectKeystroke 
	self assert: (self command keystroke = $m)! !

!OBCmdBrowseImplementorsTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2007 19:49'!
test03DoesntWantButton
	self assert: self command wantsButton! !

!OBCmdBrowseImplementorsTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/15/2006 20:23'!
theClass
	^ self class! !

OBCmdSelectorNodeTest subclass: #OBCmdBrowseInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdBrowseInheritanceTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/17/2006 21:19'!
expectedBrowser
	^ OBInheritanceBrowser! !

!OBCmdBrowseInheritanceTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:22'!
factory
	^OBCmdBrowseInheritance! !

!OBCmdBrowseInheritanceTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2007 19:48'!
test03DoesntWantButton
	self assert: self command wantsButton! !

!OBCmdBrowseInheritanceTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/17/2006 21:29'!
test08ExecutionOpensChasingBrowser
	| node browser |
	node := OBMethodNode on: #setUp inClass: TestCase.
	[self executeOn: node for: self] 
		on: OBBrowseRequest
		do: [:req | browser := req browser].
	self assert: (browser isKindOf: self expectedBrowser).
	self assert: (browser currentOrRootNode = node)! !

!OBCmdBrowseInheritanceTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/17/2006 21:10'!
theClass
	^ self class! !

OBCmdSelectorNodeTest subclass: #OBCmdBrowseSendersTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdBrowseSendersTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/17/2006 21:19'!
expectedBrowser
	^ OBSendersBrowser! !

!OBCmdBrowseSendersTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:22'!
factory
	^OBCmdBrowseSenders! !

!OBCmdBrowseSendersTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/15/2006 21:01'!
test02HasCorrectKeystroke 
	self assert: (self command keystroke = $n)! !

!OBCmdBrowseSendersTest methodsFor: 'as yet unclassified' stamp: 'cwp 3/11/2007 19:48'!
test03DoesntWantButton
	self assert: self command wantsButton! !

!OBCmdBrowseSendersTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/11/2006 20:59'!
theClass
	^ self class! !

!OBCmdSelectorNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:14'!
isAbstract
	^ self name = #OBCmdSelectorNodeTest
	
! !

!OBCmdSelectorNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 10/15/2006 20:25'!
shouldInheritSelectors
	^ true! !

!OBCmdSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/17/2006 21:19'!
expectedBrowser
	self subclassResponsibility ! !

!OBCmdSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/17/2006 21:16'!
isSelected: anObject
	^ isSelected! !

!OBCmdSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/15/2006 20:22'!
test04ConditionAcceptsMethod
	| node |
	isSelected _ true.
	node _ OBMethodNode on: #setUp inClass: self class.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/15/2006 20:22'!
test05ConditionAcceptsMethodVersion
	| node |
	isSelected _ true.
	node _ OBMethodVersionNode on: self.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/15/2006 20:22'!
test06ConditionAcceptsSelector
	| node |
	isSelected _ true.
	node _ OBSelectorNode on: #setUp.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/17/2006 21:15'!
test07ConditionRejectsParent
	| node |
	isSelected _ false.
	node _ OBSelectorNode on: #setUp.
	self deny: (self isActiveOn: node for: self)! !

!OBCmdSelectorNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/17/2006 21:25'!
test08ExecutionOpensChasingBrowser
	| node browser |
	node := OBSelectorNode on: #setUp.
	[self executeOn: node for: self] 
		on: OBBrowseRequest
		do: [:req | browser := req browser].
	self assert: (browser isKindOf: self expectedBrowser).
	self assert: browser root = node! !

OBCommandTest subclass: #OBCmdSubclassTemplateTest
	instanceVariableNames: 'isSelected handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdSubclassTemplateTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/7/2006 23:28'!
announce: anAnnouncement
	handler value: anAnnouncement! !

!OBCmdSubclassTemplateTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/7/2006 23:04'!
factory
	^ OBCmdSubclassTemplate! !

!OBCmdSubclassTemplateTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/7/2006 23:14'!
isSelected: anObject
	^ isSelected! !

!OBCmdSubclassTemplateTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/7/2006 23:11'!
test04ConditionAcceptsClass
	| node |
	node _ OBClassNode on: self class.
	isSelected _ true.
	self assert: (self isActiveOn: node for: self)! !

!OBCmdSubclassTemplateTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/7/2006 23:12'!
test05ConditionIgnoresParentNode
	| node |
	node _ OBClassNode on: self class.
	isSelected _ false.
	self deny: (self isActiveOn: node for: self).
	! !

!OBCmdSubclassTemplateTest methodsFor: 'as yet unclassified' stamp: 'cwp 12/7/2006 23:38'!
test06ChangesDefinition
	| ann node |
	handler _ [:arg | ann _ arg].
	node _ OBClassNode on: self class.
	self executeOn: node for: self.
	
	self assert: (ann isKindOf: OBDefinitionChanged).
	self assert: (ann definition text beginsWith: self class name)
! !

OBCommandTest subclass: #OBCmdTextualTest
	instanceVariableNames: 'isSelected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

OBCmdTextualTest subclass: #OBCmdBrowseImplementorsOfItTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdBrowseImplementorsOfItTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/16/2006 21:41'!
browserClass
	^ OBImplementorsBrowser! !

!OBCmdBrowseImplementorsOfItTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:21'!
factory
	^OBCmdBrowseImplementorsOfIt! !

!OBCmdBrowseImplementorsOfItTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/16/2006 21:44'!
test02HasCorrectKeystroke 
	self assert: (self command keystroke = $m)! !

OBCmdTextualTest subclass: #OBCmdBrowseSendersOfItTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCmdBrowseSendersOfItTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/16/2006 21:41'!
browserClass
	^ OBSendersBrowser! !

!OBCmdBrowseSendersOfItTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:22'!
factory
	^OBCmdBrowseSendersOfIt! !

!OBCmdBrowseSendersOfItTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/16/2006 21:44'!
test02HasCorrectKeystroke 
	self assert: (self command keystroke = $n)! !

!OBCmdTextualTest class methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:14'!
isAbstract
	^ self name = #OBCmdTextualTest! !

!OBCmdTextualTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/16/2006 21:12'!
test04ConditionAlwaysAnswersTrue
	self assert: (self isActiveOn: nil for: nil)! !

!OBCmdTextualTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/16/2006 23:20'!
test05EnabledIfSelectorPresent
	| selection text |
	text _ 'setUp'.
	selection _ OBTextSelection on: (1 to: text size) inText: text.
	self assert: (self isEnabledOn: selection for: self)! !

!OBCmdTextualTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/16/2006 23:08'!
test06DisabledIfSelectorNotPresent
	| selection |
	selection _ OBTextSelection on: (1 to: 3) inText: '234'.
	self deny: (self isEnabledOn: selection for: self)! !

!OBCmdTextualTest methodsFor: 'as yet unclassified' stamp: 'cwp 10/16/2006 21:21'!
test07ExecutionOpensChasingBrowser
	| browser selection |
	selection := OBTextSelection onAllOf: 'setUp'.
	[self executeOn: selection for: self] 
		on: OBBrowseRequest
		do: [:req | browser := req browser].
	self assert: (browser isKindOf: self browserClass).
	self assert: browser root = (OBSelectorNode on: #setUp)! !

!OBCmdTextualTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/1/2006 22:38'!
test08TakesText
	self assert: self factory takesText! !

!OBCmdTextualTest methodsFor: 'as yet unclassified' stamp: 'cwp 11/1/2006 22:38'!
test09DoesntTakeNodes
	self deny: self factory takesNodes! !

!OBCommandTest class methodsFor: 'as yet unclassified' stamp: 'cwp 11/2/2006 00:13'!
isAbstract
	^ self name == #OBCommandTest! !

!OBCommandTest class methodsFor: 'as yet unclassified' stamp: 'cwp 10/7/2006 11:15'!
shouldInheritSelectors
	^ true! !

!OBCommandTest methodsFor: 'support' stamp: 'cwp 11/1/2006 22:38'!
command
	^self factory on: nil for: nil! !

!OBCommandTest methodsFor: 'support' stamp: 'cwp 11/1/2006 22:38'!
executeOn: target for: requestor 
	| command |
	command := self factory on: target for: requestor.
	^command execute! !

!OBCommandTest methodsFor: 'support' stamp: 'cwp 11/1/2006 22:38'!
isActiveOn: target for: requestor 
	| command |
	command := self factory on: target for: requestor.
	^command isActive! !

!OBCommandTest methodsFor: 'support' stamp: 'cwp 11/1/2006 22:38'!
isEnabledOn: target for: requestor 
	| command |
	command := self factory on: target for: requestor.
	^command isEnabled! !

!OBCommandTest methodsFor: 'tests' stamp: 'cwp 10/15/2006 16:42'!
test01LabelIsString
	self assert: self command label isString! !

!OBCommandTest methodsFor: 'tests' stamp: 'cwp 10/15/2006 16:42'!
test02HasCorrectKeystroke
	self assert: self command keystroke isNil! !

!OBCommandTest methodsFor: 'tests' stamp: 'cwp 10/15/2006 16:42'!
test03DoesntWantButton
	self deny: self command wantsButton! !

TestCase subclass: #OBMercuryPanelTest
	instanceVariableNames: 'isSearch node announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBMercuryPanelTest methodsFor: 'emulating' stamp: 'cwp 4/15/2007 23:13'!
addChild: aNode
	node _ aNode! !

!OBMercuryPanelTest methodsFor: 'emulating' stamp: 'cwp 4/15/2007 23:52'!
announce: anObject
	^ announcer announce: anObject! !

!OBMercuryPanelTest methodsFor: 'emulating' stamp: 'cwp 4/15/2007 23:42'!
announcer
	^ announcer! !

!OBMercuryPanelTest methodsFor: 'emulating' stamp: 'cwp 4/18/2007 23:57'!
isClassBrowser
	^ isSearch not! !

!OBMercuryPanelTest methodsFor: 'emulating' stamp: 'cwp 4/15/2007 22:46'!
isSearchBrowser
	^ isSearch! !

!OBMercuryPanelTest methodsFor: 'emulating' stamp: 'cwp 4/18/2007 23:58'!
jumpTo: aNode 
	node _ aNode! !

!OBMercuryPanelTest methodsFor: 'emulating' stamp: 'cwp 4/15/2007 23:51'!
noteChanges
	node _ #noteChanges! !

!OBMercuryPanelTest methodsFor: 'support' stamp: 'cwp 4/15/2007 22:33'!
panel
	^ OBMercuryPanel inBrowser: self! !

!OBMercuryPanelTest methodsFor: 'emulating' stamp: 'cwp 4/15/2007 23:13'!
root
	^ self! !

!OBMercuryPanelTest methodsFor: 'running' stamp: 'cwp 4/15/2007 23:39'!
setUp
	isSearch _ false.
	announcer _ OBAnnouncer new.! !

!OBMercuryPanelTest methodsFor: 'tests' stamp: 'cwp 4/15/2007 23:15'!
testAddsChildInSearchBrowser
	isSearch _ true.
	self panel accept: 'value' notifying: self.
	self assert: (node isKindOf: OBImplementorSearchNode)
	! !

!OBMercuryPanelTest methodsFor: 'tests' stamp: 'cwp 4/15/2007 23:51'!
testBrowseIsRefreshedIfSelectionIsVetoed

	isSearch _ true.
	announcer observe: OBAboutToChange do: [:ann | ann veto].
	self panel accept: 'value' notifying: self.
	self assert: (node == #noteChanges)! !

!OBMercuryPanelTest methodsFor: 'tests' stamp: 'cwp 4/18/2007 23:59'!
testClassName
	| panel |
	panel _ self panel.
	self 
		shouldnt: [panel accept: 'String' notifying: self]
		raise: OBBrowseRequest.
	self assert: (node isKindOf: OBClassNode).
	self assert: (node theClass = String)! !

!OBMercuryPanelTest methodsFor: 'tests' stamp: 'cwp 4/19/2007 00:00'!
testClassRefs
	| panel request |
	panel _ self panel.
	[panel accept: self class name printString notifying: self]
		on: OBBrowseRequest
		do: [:r | request _ r].
	self deny: request isNil.
	self assert: (request browser isKindOf: OBSearchBrowser).
	self assert: request browser currentOrRootNode query = self class name! !

!OBMercuryPanelTest methodsFor: 'tests' stamp: 'cwp 4/15/2007 22:58'!
testDoesntOpenNewSearchBrowser
	isSearch _ true.
	self 
		shouldnt: [self panel accept: 'value' notifying: self]
		raise: OBBrowseRequest.
	! !

!OBMercuryPanelTest methodsFor: 'tests' stamp: 'cwp 4/19/2007 00:09'!
testFindClass
	| panel |
	panel _ self panel.
	isSearch _ true.
	panel accept: 'Strin*' notifying: self.
	self assert: (node isKindOf: OBClassSearchNode).
	self assert: (node query = 'Strin')! !

!OBMercuryPanelTest methodsFor: 'tests' stamp: 'cwp 4/19/2007 00:44'!
testFindMethod
	| panel |
	panel _ self panel.
	isSearch _ true.
	panel accept: 'valu*' notifying: self.
	self assert: (node isKindOf: OBMethodSearchNode).
	self assert: (node query = 'valu')! !

!OBMercuryPanelTest methodsFor: 'tests' stamp: 'cwp 4/15/2007 22:34'!
testImplementors
	| panel request |
	panel _ self panel.
	[panel accept: 'value' notifying: self]
		on: OBBrowseRequest
		do: [:r | request _ r].
	self deny: request isNil.
	self assert: (request browser isKindOf: OBSearchBrowser).
	self assert: request browser currentOrRootNode query = #value! !

!OBMercuryPanelTest methodsFor: 'tests' stamp: 'cwp 4/15/2007 22:34'!
testMorph
	| panel morph |
	panel _ self panel.
	morph _ OBMorphBuilder build: panel.
	self assert: (morph isKindOf: OBPluggableTextMorph)! !

!OBMercuryPanelTest methodsFor: 'tests' stamp: 'cwp 4/15/2007 23:43'!
testNodeIsSelected
	| ann |
	isSearch _ true.
	announcer observe: OBSelectingNode do: [:arg | ann _ arg].
	self panel accept: 'value' notifying: self.
	self assert: (ann node isKindOf: OBImplementorSearchNode)! !

!OBMercuryPanelTest methodsFor: 'tests' stamp: 'cwp 4/15/2007 22:38'!
testSenders
	| panel request |
	panel _ self panel.
	[panel accept: '#value' notifying: self]
		on: OBBrowseRequest
		do: [:r | request _ r].
	self deny: request isNil.
	self assert: (request browser isKindOf: OBSearchBrowser).
	self assert: request browser currentOrRootNode query = #value! !

TestCase subclass: #OBMethodDefinitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBMethodDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/28/2005 23:45'!
testDoItReceiverCategory
	| panel |
	panel _ OBMethodDefinition inCategory: #letters inClass: BogusA.
	self deny: panel doItReceiver isMeta! !

!OBMethodDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/28/2005 23:49'!
testDoItReceiverClassMethod
	| panel |
	panel _ OBMethodDefinition
				source: (BogusA class sourceCodeAt: #a)
				inClass: BogusA class.
	self deny: panel doItReceiver isMeta! !

!OBMethodDefinitionTest methodsFor: 'as yet unclassified' stamp: 'cwp 2/28/2005 23:48'!
testDoItReceiverInstMethod
	| panel |
	panel _ OBMethodDefinition
				source: (BogusA sourceCodeAt: #one)
				inClass: BogusA.
	self deny: panel doItReceiver isMeta! !

TestCase subclass: #OBMethodVersionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBMethodVersionTest methodsFor: 'constants' stamp: ''!
fakeSourceFileArray
	^ OBSourceFilesResource current sources! !

!OBMethodVersionTest methodsFor: 'constants' stamp: ''!
methodReference
	| ref |
	ref := MethodReference new.
	ref setStandardClass: self class methodSymbol: #testScanFromMethodRef.
	^ ref! !

!OBMethodVersionTest methodsFor: 'testing' stamp: ''!
testScanFromMethodRef
	| changes |
	changes := OBMethodVersion versionsOfMethod: self methodReference.
	self deny: changes isEmpty! !

!OBMethodVersionTest methodsFor: 'testing' stamp: ''!
testScanFromPointer
	| changes sourcePointer sources |
	sources :=  self fakeSourceFileArray.
	sourcePointer := sources sourcePointerFromFileIndex: 2 andPosition: 488.
	changes := OBMethodVersion scan: sources from: sourcePointer.
	self assert: changes size = 6.
	changes do: [:ea | 
					self assert: ea theClassName = #BogusA.
					self assert: ea category = 'as yet unclassified'.
					self assert: (ea stamp beginsWith: 'cwp 3/11/2004 20:0')]! !

!OBMethodVersionTest methodsFor: 'testing' stamp: ''!
testScanFromPointerToClassMethod
	| changes sourcePointer sources |
	sources :=  self fakeSourceFileArray.
	sourcePointer := sources sourcePointerFromFileIndex: 2 andPosition: 694.
	changes := OBMethodVersion scan: sources from: sourcePointer.
	self assert: changes size = 2.
	changes do: [:ea | 
					self assert: ea theClassName = #'BogusA class'.
					self assert: ea category = 'as yet unclassified'.
					self assert: (ea stamp beginsWith: 'cwp 3/11/2004 20:0')]! !

TestCase subclass: #OBSearchNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

OBSearchNodeTest subclass: #OBClassRefSearchNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBClassRefSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 20:27'!
nodeClass
	^ OBClassRefSearchNode ! !

!OBClassRefSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/7/2007 23:33'!
refersToClass
	^ Class! !

!OBClassRefSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 21:19'!
searchNodeForThisClass 
	^ OBClassRefSearchNode on: #Class.! !

!OBClassRefSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/8/2007 00:03'!
testAncestryOfMethodNode
	| node node2 |
	node _ OBClassRefSearchNode on: #Class.
	node2 _ OBMethodNode on: #testAncestryOfMethodNode inClass: self class.
	self assert: (node isAncestorOf: node2).! !

!OBClassRefSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/13/2007 23:57'!
testClassesNotDuplicated
	| node classes |
	node _ OBClassRefSearchNode on: #Class.
	classes _ node classes.
	self assert: classes size = classes asSet size
	! !

!OBClassRefSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/7/2007 23:29'!
testName
	| node |
	node _ OBClassRefSearchNode on: 'Class'.
	self assert: node name = '#Class'! !

OBSearchNodeTest subclass: #OBClassSearchNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBClassSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 20:28'!
nodeClass
	^ OBClassSearchNode! !

!OBClassSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 21:18'!
searchNodeForThisClass
	^ OBClassSearchNode on: 'Class'.! !

!OBClassSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2007 00:09'!
testName
	| node |
	node _ OBClassSearchNode on: 'Class'.
	self assert: node name = 'Class*'! !

OBSearchNodeTest subclass: #OBImplementorSearchNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBImplementorSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 22:01'!
nodeClass
	^OBImplementorSearchNode! !

!OBImplementorSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 22:01'!
searchNodeForThisClass
	^OBImplementorSearchNode on: #searchNodeForThisClass! !

!OBImplementorSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 22:01'!
testAncestryOfMethodNode
	| node node2 |
	node := OBImplementorSearchNode on: #testAncestryOfMethodNode.
	node2 := OBMethodNode on: #testAncestryOfMethodNode inClass: self class.
	self assert: (node isAncestorOf: node2)! !

!OBImplementorSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 22:01'!
testName
	| node |
	node := OBImplementorSearchNode on: 'testName'.
	self assert: node name = 'testName'! !

OBSearchNodeTest subclass: #OBMethodSearchNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBMethodSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2007 00:39'!
nodeClass
	^ OBMethodSearchNode! !

!OBMethodSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2007 00:25'!
searchNodeForThisClass
	^ OBMethodSearchNode on: #searchNodeForThisC! !

!OBMethodSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2007 00:41'!
testAncestryOfMethodNode
	| node node2 |
	node := OBMethodSearchNode on: #testAncestry.
	node2 := OBMethodNode on: #testAncestryOfMethodNode inClass: self class.
	self assert: (node isAncestorOf: node2). ! !

!OBMethodSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2007 00:40'!
testName
	| node |
	node _ OBMethodSearchNode on: #yoursel.
	self assert: node name = 'yoursel*'! !

!OBSearchNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 20:29'!
isAbstract
	^ self name = #OBSearchNodeTest! !

!OBSearchNodeTest class methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 20:29'!
shouldInheritSelectors
	^ true! !

!OBSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 20:27'!
testAncestryOfEqualNode
	| node node2 |
	node _ self nodeClass on: 'Test'.
	node2 _ self nodeClass on: 'Test'.
	self assert: (node isAncestorOf: node2).! !

!OBSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 21:18'!
testAncestryOfMethodNode
	| node node2 |
	node _ OBClassSearchNode on: 'Test'.
	node2 _ OBMethodNode on: #testAncestryOfMethodNode inClass: self class.
	self assert: (node isAncestorOf: node2).! !

!OBSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 21:56'!
testClasses
	| node classes |
	node _ self searchNodeForThisClass.
	classes _ node classes.
	self assert: classes size >= 1.
	self assert: (classes allSatisfy: [:ea | ea isKindOf: OBClassNode]).
	self assert: (classes anySatisfy: [:ea | ea theClass = self class])! !

OBSearchNodeTest subclass: #OBSenderSearchNodeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBSenderSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 21:16'!
nodeClass
	^ OBSenderSearchNode! !

!OBSenderSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 21:21'!
searchNodeForThisClass
	^ OBSenderSearchNode on: #yourself! !

!OBSenderSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 21:23'!
sendsYourself
	^ self yourself! !

!OBSenderSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 21:59'!
testAncestryOfMethodNode
	| node node2 |
	node _ OBSenderSearchNode on: #assert:.
	node2 _ OBMethodNode on: #testAncestryOfMethodNode inClass: self class.
	self assert: (node isAncestorOf: node2).! !

!OBSenderSearchNodeTest methodsFor: 'as yet unclassified' stamp: 'cwp 4/15/2007 21:11'!
testName
	| node |
	node _ OBSenderSearchNode on: #yourself.
	self assert: node name = '#yourself'! !

TestCase subclass: #OBSystemBrowserAdaptorTest
	instanceVariableNames: 'oldDefault browser registry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBSystemBrowserAdaptorTest methodsFor: 'running' stamp: 'cwp 12/5/2004 21:58'!
openWith: aBlock
	aBlock
		on: OBBrowseRequest
		do: [:n | browser _ n browser].
	self deny: browser isNil.
! !

!OBSystemBrowserAdaptorTest methodsFor: 'running' stamp: 'cwp 6/3/2006 19:25'!
setUp
	registry _ Smalltalk at: #SystemBroser ifAbsent: [nil].
	registry ifNotNil:
		[oldDefault _ registry defaultOrNil.
		registry default: OBSystemBrowserAdaptor]! !

!OBSystemBrowserAdaptorTest methodsFor: 'running' stamp: 'cwp 6/3/2006 19:28'!
tearDown
	registry ifNotNil: [registry default: oldDefault]! !

!OBSystemBrowserAdaptorTest methodsFor: 'testing' stamp: 'cwp 6/3/2006 19:27'!
testDefaultOpenBrowser
	registry ifNil: [^ self].
	self openWith: [registry defaultOpenBrowser].
	self assert: browser currentNode isNil! !

!OBSystemBrowserAdaptorTest methodsFor: 'testing' stamp: 'cwp 6/3/2006 19:27'!
testFullOnClassSelector
	registry ifNil: [^ self].
	self openWith: [Browser fullOnClass: BogusA selector: #one].
	self assert: browser currentNode theClass = BogusA.
	self assert: browser currentNode selector = #one! !

TestCase subclass: #OBTextCmdTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBTextCmdTest methodsFor: 'emulating' stamp: 'cwp 4/18/2006 21:10'!
announcer
	^ OBAnnouncer new! !

!OBTextCmdTest methodsFor: 'asserting' stamp: 'cwp 9/24/2005 00:10'!
assertPanel: actionBlock browser: assertionBlock
	| notification panel |
	panel := OBDefinitionPanel inBrowser: self.
	[self assert: (actionBlock value: panel)]
		on: OBBrowseRequest
		do: [:ex | notification := ex].
	self deny: notification isNil.
	self assert: (assertionBlock value: notification browser)! !

!OBTextCmdTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 01:30'!
testBrowseItWithClass
	self
		assertPanel: [:p | p browseIt: #BogusA]
		browser: [:browser | browser currentNode theClass = BogusA]! !

!OBTextCmdTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 01:31'!
testBrowseItWithGlobal
	self
		assertPanel: [:p | p browseIt: #Transcript]
		browser: [:browser | browser currentNode theClass = TranscriptStream]
! !

!OBTextCmdTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 01:32'!
testBrowseItWithSelector
	self
		assertPanel: [:p | p browseIt: #testBrowseItWithSelector]
		browser: [:browser | browser root selector = #testBrowseItWithSelector]! !

!OBTextCmdTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 01:35'!
testImpementorsOfIt
	self
		assertPanel: [:p | p implementorsOfIt: #testBrowseItWithSelector]
		browser: [:browser | browser root selector = #testBrowseItWithSelector]! !

!OBTextCmdTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 01:43'!
testReferencesToIt
	self
		assertPanel: [:p | p referencesToIt: #BogusA]
		browser: [:browser | browser root theClass = BogusA]! !

!OBTextCmdTest methodsFor: 'tests' stamp: 'cwp 10/31/2004 01:36'!
testSendersOfIt
	self
		assertPanel: [:p | p sendersOfIt: #testBrowseItWithSelector]
		browser: [:browser | browser root selector = #testBrowseItWithSelector]! !

OBBrowserTest subclass: #OBAccessBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBAccessBrowserTest methodsFor: 'configuration' stamp: 'avi 9/17/2005 01:39'!
browserClass
	^ OBVariablesBrowser! !

!OBAccessBrowserTest methodsFor: 'configuration' stamp: 'dvf 8/31/2005 13:17'!
node
	^BogusB asNode! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: ''!
testInitalDisplay
	self assertListAt: 1 contains: BogusInfo bInstVarNames! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: 'cwp 9/13/2005 21:39'!
testSelectCVar
	self clickButtonLabeled: 'class'.
	self select: 'FirstClassVariableB'.
	self assertListAt: 2 contains: #('BogusB>>accessesCVar' 
								   'BogusB class>>accessesCVarAlso'
								   'BogusB>>foreign2')! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: ''!
testSelectIVarAccessor
	self select: 'firstInstanceVariableB'.
	self select: 'BogusB>>accessesIvar'.
	self assertListAt: 3 includes: #('BogusB>>sendsAccessesIvar')! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: 'cwp 9/13/2005 21:38'!
testSelectIvar
	self select: 'firstInstanceVariableB'.
	self assertListAt: 2 contains: #('BogusB>>accessesIvar' 'BogusB>>foreign')! !

!OBAccessBrowserTest methodsFor: 'testing' stamp: ''!
testSelectSender
	self select: 'firstInstanceVariableB'.
	self select: 'BogusB>>accessesIvar'.
	self select: 'BogusB>>sendsAccessesIvar'.
	self assertListAt: 4 contains: #('BogusB>>sendsSendsAccessesIvar')
! !

OBBrowserTest subclass: #OBChasingBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBChasingBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/8/2004 22:59'!
isAbstract
	^ self name = #OBChasingBrowserTest! !

!OBChasingBrowserTest methodsFor: 'tests' stamp: 'cwp 12/8/2004 23:03'!
testChaseDisplay
	self clickButtonLabeled: 'chase'.
	self 
		assertListAt: 1 
		contains: self initialList! !

!OBChasingBrowserTest methodsFor: 'tests' stamp: 'cwp 12/8/2004 22:58'!
testInitialDisplay
	self 
		assertListAt: 1 
		contains: self initialList! !

OBChasingBrowserTest subclass: #OBImplementorsBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBImplementorsBrowserTest methodsFor: 'configuration' stamp: 'avi 9/17/2005 01:40'!
browserClass
	^ OBImplementorsBrowser! !

!OBImplementorsBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/8/2004 23:37'!
initialList
	^ #('BogusB>>sendsSendsAccessesIvar')! !

!OBImplementorsBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/8/2004 23:37'!
node
	"We don't want this method to show up in senders 
	of #sendsSendsAccesses, since other tests 
	aren't expecting it."
	
	| selector |
	selector := ('sendsSendsAccesses', 'Ivar') asSymbol.
	^ OBMethodNode on: selector inClass: BogusB! !

!OBImplementorsBrowserTest methodsFor: 'tests' stamp: 'cwp 12/8/2004 23:41'!
testMessagesOf
	self clickButtonLabeled: 'chase'.
	self select: 'BogusB>>sendsSendsAccessesIvar'.
	self assertListAt: 2 contains: #('sendsAccessesIvar')! !

OBChasingBrowserTest subclass: #OBSendersBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBSendersBrowserTest methodsFor: 'configuration' stamp: 'avi 9/17/2005 01:40'!
browserClass
	^ OBSendersBrowser! !

!OBSendersBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/8/2004 22:59'!
initialList
	^  #('BogusB>>sendsAccessesIvar')! !

!OBSendersBrowserTest methodsFor: 'configuration' stamp: 'cwp 12/8/2004 22:44'!
node
	"We don't want this method to show up in senders 
	of #accessesIvar, since that's what we're testing"
	
	| selector |
	selector := ('accesses', 'Ivar') asSymbol.
	^ OBMethodNode on: selector inClass: BogusB! !

!OBSendersBrowserTest methodsFor: 'tests' stamp: 'cwp 12/8/2004 23:15'!
testSendersOf
	self clickButtonLabeled: 'chase'.
	self select: 'BogusB>>sendsAccessesIvar'.
	self assertListAt: 2 contains: #('BogusB>>sendsSendsAccessesIvar')! !

OBBrowserTest subclass: #OBCodeBrowserTest
	instanceVariableNames: 'damage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBCodeBrowserTest class methodsFor: 'as yet unclassified' stamp: ''!
isAbstract
	^ self name = #OBCodeBrowserTest! !

!OBCodeBrowserTest class methodsFor: 'as yet unclassified' stamp: ''!
resources
	^ Array with: BogusSnapshotResource! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
altMethodA
	^ 'a
	^ $B'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
altMethodOne
	^ 'one
	^ 11'! !

!OBCodeBrowserTest methodsFor: 'asserting' stamp: ''!
assertIsClassSide
	self assertButtonSelected: 'class'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
bogusAClassTemplate
	^  'BogusA class
	instanceVariableNames: '''''! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:51'!
bogusAName
	^'BogusA'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
bogusATemplate
	^ 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	package: ''', BogusInfo packageName, '''
	category: ''Base'''! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
bogusBComment
	^ 'A comment for BogusB'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
bogusCDefinition
 ^ 'Object subclass: #BogusC
	instanceVariableNames: ''foo''
	classVariableNames: ''''
	poolDictionaries: ''''
	package: ''', self bogusPackageName, '''
	category: ''Base'''! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:40'!
bogusCategoryName
	^ BogusInfo baseCategory! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: 'cwp 12/10/2004 21:15'!
bogusClassNames
	^BogusInfo baseClassNames! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
bogusDDefinition
 ^ 'Object subclass: #BogusD
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	package: ''', BogusInfo packageName, '''
	category: ''Base'''! !

!OBCodeBrowserTest methodsFor: 'running' stamp: ''!
browserResource
	^ self class resources first current! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
classTemplate
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	package: ''', BogusInfo packageName, '''
	category: ''Base'''! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: ''!
deselectBogusCategory
	self deselect: self bogusCategoryName! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakeAClassTemplate
	^  self deprecated: 'Use #bogusAClassTemplate'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakeAComment
	self deprecated: 'Use BogusInfo>>aComment instead'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakeATemplate
	self deprecated: 'Use #bogusATemplate instead'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakeClassBComment
	self deprecated: 'Use #bogusBComment'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakeClassCDefinition
	self deprecated: 'Use #bogusCDefinition'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakeClassDDefinition
	self deprecated: 'Use #bogusDDefinition'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
fakePackageName
	self deprecated: 'Use BogusInfo>>packageName'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
methodA
	^ 'a
	^ $A'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
methodFour
	^ 'four
	^ 4'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
methodOne
	^ 'one
	^ 1'! !

!OBCodeBrowserTest methodsFor: 'constants' stamp: ''!
methodTemplate
	^ 'message selector and argument names
	"comment stating purpose of message"

	| temporary variable names |
	statements'! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 3/1/2006 19:52'!
runCase
	SystemChangeNotifier uniqueInstance doSilently: [super runCase]! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 3/1/2006 19:52'!
runCaseAsFailure: aSemaphore
	SystemChangeNotifier uniqueInstance doSilently: [super runCaseAsFailure: aSemaphore]! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/13/2004 00:01'!
selectBogusA
	self select: self bogusAName! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: ''!
selectBogusCategory
	self select: self bogusCategoryName! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: ''!
selectBogusPackage
	! !

!OBCodeBrowserTest methodsFor: 'running' stamp: 'cwp 3/23/2007 23:57'!
setUp
	damage := BogusDamage new.
	model _ self browserClass metaNode: self metagraph node: self node.
	morph _ OBMorphBuilder build: model.
	self forceLayout! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: ''!
switchToClassSide
	self clickButtonLabeled: 'class'! !

!OBCodeBrowserTest methodsFor: 'simulating' stamp: ''!
switchToComment
	self clickButtonLabeled: '?'! !

!OBCodeBrowserTest methodsFor: 'running' stamp: ''!
tearDown
	damage repair! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:01'!
testButtonRemoval
	self selectBogusCategory.
	self selectBogusA.
	self deselectBogusCategory.
	self assertNoButtonsVisible! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:26'!
testColumnClearing
	self selectBogusCategory.
	self selectBogusA.
	self select: 'numbers'.
	self select: 'one'.
	self switchToClassSide.
	self assertAListIncludes: self bogusClassNames.
	self assertAListIncludes: #('testing' 'capitals').
	self denyAListIncludes: #('letters' 'numbers').
	self denyAListIncludes: #('one' 'two' 'three').
	self assertTextIs: self bogusAClassTemplate! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: ''!
testCreateClassFromClass
	self selectBogusCategory.
	self select: 'BogusC'.
	self setText: self bogusDDefinition.
	damage add: #Definition ofClass: #BogusD.
	self assertAListIncludes: #(BogusD).
	self assertCurrentItemIs: #BogusD.! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:09'!
testCreateClassFromTemplate
	self selectBogusCategory.
	damage add: #Definition ofClass: #BogusD.
	self setText: self bogusDDefinition.
	self assertAListIncludes: #(BogusD).
	self assertCurrentItemIs: #BogusD ! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/20/2004 00:37'!
testCreateMethodFromMethod
	self selectBogusCategory.
	self selectBogusA.
	self select: 'numbers'.
	self select: 'one'.
	damage add: #four ofClass: #BogusA.
	self setText: self methodFour.
	self assertAListMatches: #('one' 'two' 'three' 'four' 'five').
	self assertCurrentItemIs: 'four' 
! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:04'!
testCreateMethodFromTemplate
	self selectBogusCategory.
	self selectBogusA.
	self select: 'letters'.
	self setText: self methodFour.
	damage add: #four ofClass: #BogusA.
	self assertAListMatches: #('a' 'b' 'four').
	self assertCurrentItemIs: 'four' 
! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:04'!
testDeselectFakeA
	self selectBogusCategory.
	self selectBogusA.
	self deselect: self bogusAName.
	self assertAListIncludes: {self bogusCategoryName}.
	self assertAListIncludes: self bogusClassNames.
	self denyAListIncludes: #('letters' 'numbers').
	self assertTextIs: self classTemplate.! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/10/2004 23:46'!
testEditClass
	self selectBogusCategory.
	self select: 'BogusC'.
	self setText: self bogusCDefinition.
	damage add: #Definition ofClass: #BogusC.
	self assertAListIncludes: self bogusClassNames.
	self assertCurrentItemIs: #BogusC.
	self assert: BogusC instVarNames = #(foo)! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:04'!
testEditClassMethod
	self selectBogusCategory.
	self selectBogusA.
	self switchToClassSide.
	self select: 'capitals'.
	self select: 'a'.
	self setText: self altMethodA.
	damage add: #a ofClass: #BogusA isMeta: true.
	self assertAListMatches: #('a' 'b').
	self assertCurrentItemIs: 'a'.
	self assert: $B = BogusA a! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/15/2004 21:06'!
testEditComment
	self selectBogusCategory.
	self selectBogusA.
	self switchToComment.
	self setText: self bogusBComment.
	damage add: #Comment ofClass: #BogusA.
	self assertAListIncludes: self bogusClassNames.
	self assertCurrentItemIs: #BogusA.
	self assert: BogusA comment = self bogusBComment! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:04'!
testEditMethod
	self selectBogusCategory.
	self selectBogusA.
	self select: 'numbers'.
	self select: 'one'.

	damage add: #one ofClass: #BogusA.
	self setText: self altMethodOne.
	self assertAListMatches: #('one' 'two' 'three' 'five').
	self assertCurrentItemIs: 'one'.
	self assert: 11 = BogusA new one! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'dvf 8/31/2005 13:14'!
testJumpToBogusA
	self selectBogusPackage.
	model jumpTo: (BogusA asNode).
	self assertCurrentItemIs: self bogusAName! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: ''!
testJumpToCapitals
	self selectBogusPackage.
	model jumpTo: (OBMethodCategoryNode 
					on: 'capitals' 
					inClass: BogusA class).
	self assertCurrentItemIs: 'capitals'.
	self assertIsClassSide.! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/12/2004 23:55'!
testJumpToFakes
	self selectBogusPackage.
	model jumpTo: (OBClassCategoryNode 
						on: self bogusCategoryName 
						inEnvironment: Smalltalk).
	self assertCurrentItemIs: self bogusCategoryName! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: ''!
testJumpToMethodOne
	self selectBogusPackage.
	model jumpTo: (OBMethodNode 
					on: #one 
					inClass: BogusA).
	self assertCurrentItemIs: 'one'! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: ''!
testJumpToNumbers
	self selectBogusPackage.
	model jumpTo: (OBMethodCategoryNode 
					on: 'numbers' 
					inClass: BogusA).
	self assertCurrentItemIs: 'numbers'.! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 6/9/2006 23:08'!
testMethodChangedElsewhere
	self selectBogusCategory.
	self selectBogusA.
	self select: 'numbers'.
	self select: 'one'.
	self editText: 'foo'.

	damage add: #one ofClass: #BogusA.
	BogusA compile: self altMethodOne.
	model announcer announce: OBRefreshRequired new.

	self assertAListMatches: #('one' 'two' 'three' 'five').
	self assertCurrentItemIs: 'one'.
	self assert: self textMorph hasEditingConflicts
	! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:25'!
testSelectAllMethodCategory
	self selectBogusCategory.
	self selectBogusA.
	self select: '-- all --'.
	self assertAListIncludes: self bogusClassNames.
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three' 'five' 'a' 'b').
	self assertTextIs: self methodTemplate! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:26'!
testSelectBogusA
	self selectBogusCategory.
	self selectBogusA.
	self assertAListIncludes: self bogusClassNames.
	self assertAListIncludes: #('letters' 'numbers').
	self assertCurrentItemIs: self bogusAName.
	self assertTextIs: self bogusATemplate! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:23'!
testSelectBogusAClassSide
	self selectBogusCategory.
	self selectBogusA.
	self switchToClassSide.
	self assertAListIncludes: self bogusClassNames.
	self assertAListIncludes: #('capitals').
	self assertCurrentItemIs: self bogusAName.
	self assertTextIs: self bogusAClassTemplate! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:23'!
testSelectBogusAComment
	self selectBogusCategory.
	self selectBogusA.
	self switchToComment.
	self assertAListIncludes: self bogusClassNames.
	self denyAListIncludes: #('letters' 'numbers').
	self assertCurrentItemIs: self bogusAName.
	self assertTextIs: BogusInfo aComment.! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/10/2004 21:16'!
testSelectCategory
	self selectBogusCategory.
	self assertAListIncludes: {self bogusCategoryName}.
	self assertAListIncludes: self bogusClassNames.
	self assertTextIs: self classTemplate! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:26'!
testSelectNumbers
	self selectBogusCategory.
	self selectBogusA.
	self select: 'numbers'.
	self assertAListIncludes: self bogusClassNames.
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three').
	self assertTextIs: self methodTemplate.
	self assertTextIsSelected.! !

!OBCodeBrowserTest methodsFor: 'testing' stamp: 'cwp 12/13/2004 00:30'!
testSelectOne
	self selectBogusCategory.
	self selectBogusA.
	self select: 'numbers'.
	self select: 'one'.
	self assertAListIncludes: self bogusClassNames.
	self assertAListIncludes: #('letters' 'numbers').
	self assertAListIncludes: #('one' 'two' 'three').
	self assertTextIs: BogusInfo aOneSource! !

OBCodeBrowserTest subclass: #OBImageBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

OBImageBrowserTest subclass: #OBAltImageBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBAltImageBrowserTest methodsFor: 'constants' stamp: 'cwp 1/8/2005 11:39'!
bogusClassNames
	^ #('BogusA' 'BogusE' 'BogusB' 'BogusC')! !

!OBAltImageBrowserTest methodsFor: 'constants' stamp: 'avi 9/17/2005 01:12'!
metagraph
	^ OBSystemBrowser defaultMetaNode! !

OBImageBrowserTest subclass: #OBHierImageBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBHierImageBrowserTest class methodsFor: 'as yet unclassified' stamp: 'cwp 12/12/2004 23:32'!
shouldInheritSelectors
	^ true! !

!OBHierImageBrowserTest methodsFor: 'constants' stamp: 'cwp 1/8/2005 11:49'!
bogusAName
	^ 'BogusA'! !

!OBHierImageBrowserTest methodsFor: 'constants' stamp: 'cwp 1/8/2005 11:52'!
bogusClassNames
	^ #('ProtoObject' 'Object' 'BogusA' 'BogusE')! !

!OBHierImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/13/2004 00:11'!
bogusDDefinition
 ^ 'BogusA subclass: #BogusD
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self bogusCategoryName, ''''! !

!OBHierImageBrowserTest methodsFor: 'constants' stamp: 'cwp 1/8/2005 12:07'!
bogusDName
	^ 'BogusD'! !

!OBHierImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/13/2004 00:31'!
bogusEDefinition
 ^ 'BogusA subclass: #BogusE
	instanceVariableNames: ''foo''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self bogusCategoryName, ''''! !

!OBHierImageBrowserTest methodsFor: 'constants' stamp: 'cwp 1/8/2005 12:05'!
bogusEName
	^ 'BogusE'! !

!OBHierImageBrowserTest methodsFor: 'set up' stamp: 'cwp 9/23/2005 23:08'!
metagraph
	^ OBHierarchyBrowser defaultMetaNode! !

!OBHierImageBrowserTest methodsFor: 'set up' stamp: 'dvf 8/31/2005 13:17'!
node
	^BogusA asNode! !

!OBHierImageBrowserTest methodsFor: 'simulating' stamp: 'cwp 12/12/2004 23:43'!
selectBogusCategory
	! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/13/2004 00:07'!
testButtonRemoval
	"Not applicable to hierarchy browser"! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/13/2004 00:33'!
testCreateClassFromClass
	self selectBogusCategory.
	self select: self bogusEName.
	damage add: #Definition ofClass: #BogusD.
	self setText: self bogusDDefinition.
	self assertAListIncludes: {self bogusDName}.
	self assertCurrentItemIs: self bogusDName.! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/13/2004 00:15'!
testCreateClassFromTemplate
	"doesn't apply for now"! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/13/2004 00:34'!
testDeselectFakeA
	self selectBogusCategory.
	self selectBogusA.
	self deselect: self bogusAName.
	self assertAListIncludes: self bogusClassNames.
	self denyAListIncludes: #('letters' 'numbers').
	self assertTextIs: '' "for now"! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/13/2004 00:30'!
testEditClass
	self selectBogusCategory.
	self select: self bogusEName.
	damage add: #Definition ofClass: #BogusE.
	self setText: self bogusEDefinition.
	self assertAListIncludes: self bogusClassNames.
	self assertCurrentItemIs: self bogusEName.
	self assert: BogusE instVarNames = #(foo)! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/15/2004 21:13'!
testEditComment
	self selectBogusCategory.
	self selectBogusA.
	self switchToComment.
	damage add: #Comment ofClass: #BogusA.
	self setText: self bogusBComment.
	self assertAListIncludes: self bogusClassNames.
	self assertCurrentItemIs: self bogusAName.
	self assert: BogusA comment = self bogusBComment! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/15/2004 21:13'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 includes: self bogusClassNames.
	self assertTextIs: ''.! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/12/2004 23:24'!
testJumpToFakes
	"Not applicable to the hierarchy browser"! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'cwp 12/12/2004 23:44'!
testSelectCategory
	"Not applicable to the hierarchy browser"! !

!OBHierImageBrowserTest methodsFor: 'tests' stamp: 'dvf 9/5/2005 18:12'!
testSelectionPath
	self selectBogusCategory.
	self selectBogusA.
	model selectionPath = {OBClassCategoryNode on: self bogusCategoryName. OBClassNode on: self bogusAName} asOrderedCollection.! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:39'!
bogusATemplate
	^ 'Object subclass: #BogusA
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self bogusCategoryName, ''''! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:39'!
bogusCDefinition
 ^ 'Object subclass: #BogusC
	instanceVariableNames: ''foo''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self bogusCategoryName, ''''! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:39'!
bogusDDefinition
 ^ 'Object subclass: #BogusD
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self bogusCategoryName, ''''! !

!OBImageBrowserTest methodsFor: 'set up' stamp: 'cwp 12/10/2004 21:27'!
browserClass
	^ OBSystemBrowser! !

!OBImageBrowserTest methodsFor: 'constants' stamp: 'cwp 12/12/2004 23:40'!
classTemplate
	^ 'Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''', self bogusCategoryName, ''''! !

!OBImageBrowserTest methodsFor: 'set up' stamp: 'avi 9/17/2005 01:13'!
metagraph
	^ OBSystemBrowser alphabeticalMetaNode! !

!OBImageBrowserTest methodsFor: 'set up' stamp: 'cwp 12/10/2004 21:28'!
node
	^ OBEnvironmentNode forImage! !

!OBImageBrowserTest methodsFor: 'testing' stamp: 'cwp 12/12/2004 23:40'!
testInitialDisplay
	self listMorphs size = 1.
	self assertListAt: 1 includes: {self bogusCategoryName}.
	self assertTextIs: ''.
	! !

OBBrowserTest subclass: #OBInheritanceBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 12/8/2004 23:49'!
interiorNode
	^ OBMethodNode on: #isString inClass: BogusA! !

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 12/8/2004 23:49'!
leafNode
	^ OBMethodNode on: #isString inClass: BogusE! !

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'avi 9/17/2005 01:11'!
metagraph
	^ OBInheritanceBrowser defaultMetaNode! !

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 12/8/2004 23:49'!
rootNode
	^ OBCollectionNode on: {OBMethodNode 
								on: #isString 
								inClass: Object}! !

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 11/28/2004 10:22'!
setUp! !

!OBInheritanceBrowserTest methodsFor: 'running' stamp: 'cwp 3/24/2007 00:00'!
setUpWith: targetNode
	[OBInheritanceBrowser openRoot: self rootNode selection: targetNode]
		on: OBBrowseRequest
		do: [:notification | 
			model := notification browser.
			morph := OBMorphBuilder build: model].
	self forceLayout.! !

!OBInheritanceBrowserTest methodsFor: 'testing' stamp: 'cwp 9/17/2005 18:09'!
testInitialDisplay
	self setUpWith: self interiorNode.
	self 
		assertListAt: 1 contains: #('Object>>isString');
		assertListAt: 2 contains: #('BogusA>>isString' 'String>>isString');
		assertListAt: 3 contains: #('BogusE>>isString');
		assertCurrentItemIs: 'BogusA>>isString'! !

!OBInheritanceBrowserTest methodsFor: 'testing' stamp: 'cwp 9/17/2005 18:09'!
testInitialDisplay2
	self setUpWith: self leafNode.
	self 
		assertListAt: 1 contains: #('Object>>isString');
		assertListAt: 2 contains: #('BogusA>>isString' 'String>>isString');
		assertListAt: 3 contains: #('BogusE>>isString');
		assertCurrentItemIs: 'BogusE>>isString'! !

OBBrowserTest subclass: #OBReferencesBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBReferencesBrowserTest methodsFor: 'constants' stamp: 'cwp 12/1/2004 01:18'!
bogusCReferences
	^ {	'OBCodeBrowserTest>>testEditClass'.
		'OBReferencesBrowserTest>>node'.
		'OBReferencesBrowserTest>>refersToBogusC' }! !

!OBReferencesBrowserTest methodsFor: 'configuration' stamp: 'avi 9/17/2005 01:43'!
browserClass
	^ OBReferencesBrowser! !

!OBReferencesBrowserTest methodsFor: 'configuration' stamp: 'dvf 8/31/2005 13:17'!
node
	^BogusC asNode! !

!OBReferencesBrowserTest methodsFor: 'bogus' stamp: 'cwp 12/1/2004 00:58'!
refersToBogusC
	^ BogusC! !

!OBReferencesBrowserTest methodsFor: 'tests' stamp: 'cwp 12/1/2004 00:32'!
testClassNameSelection
	self select: 'OBReferencesBrowserTest>>node'.
	self assertSelectedTextIs: 'BogusC'! !

!OBReferencesBrowserTest methodsFor: 'tests' stamp: 'cwp 11/30/2004 20:31'!
testInitialDisplay
	self assertListAt: 1 contains: self bogusCReferences! !

!OBReferencesBrowserTest methodsFor: 'tests' stamp: 'cwp 12/1/2004 01:09'!
testSelectorSelection
	self select: 'OBReferencesBrowserTest>>refersToBogusC'.
	self deny: self textMorph getSelection = (9 to: 13)! !

OBBrowserTest subclass: #OBVersionsBrowserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBVersionsBrowserTest methodsFor: 'constants' stamp: 'cwp 11/27/2004 21:43'!
expectedHeadings
	^ #('BogusA>>two cwp 3/11/2004 20:07' 'BogusA>>two cwp 3/11/2004 20:06' 'BogusA>>two cwp 3/11/2004 20:06' 'BogusA>>two cwp 3/11/2004 20:07' 'BogusA>>two cwp 3/11/2004 20:06' 'BogusA>>two cwp 3/11/2004 20:06')! !

!OBVersionsBrowserTest methodsFor: 'running' stamp: 'avi 9/17/2005 01:11'!
metagraph
	^ OBVersionBrowser defaultMetaNode! !

!OBVersionsBrowserTest methodsFor: 'running' stamp: ''!
node
	^ OBMethodNode on: #two inClass: BogusA! !

!OBVersionsBrowserTest methodsFor: 'running' stamp: 'cwp 3/24/2007 00:04'!
setUp
	(BogusA compiledMethodAt: #two) setSourcePointer: self twoSourcePointer.
	[OBVersionBrowser openOn: self node]
		on: OBBrowseRequest, OBSourceFilesRequest 
		do: [:notification |
			notification isBrowseRequest
				ifTrue: [model := notification browser.
						morph := OBMorphBuilder build: model]
				ifFalse: [notification resume: self sourceFiles]].
	self forceLayout
		! !

!OBVersionsBrowserTest methodsFor: 'emulating' stamp: ''!
sourceFiles
	^ OBSourceFilesResource current sources! !

!OBVersionsBrowserTest methodsFor: 'running' stamp: ''!
tearDown
	(BogusA compiledMethodAt: #two) setSourcePointer: 0! !

!OBVersionsBrowserTest methodsFor: 'testing' stamp: ''!
testInitialDisplay
	self assertListAt: 1 contains: self expectedHeadings! !

!OBVersionsBrowserTest methodsFor: 'testing' stamp: 'cwp 11/27/2004 21:39'!
testSourceDisplay
	self select: 'BogusA>>two cwp 3/11/2004 20:07'.
	self assertTextIs: self twoLatestVersionText! !

!OBVersionsBrowserTest methodsFor: 'constants' stamp: ''!
twoLatestVersionText
	^  'two
	^ 6' asText makeSelectorBold! !

!OBVersionsBrowserTest methodsFor: 'constants' stamp: ''!
twoSourcePointer
	^ 33555020! !

TestResource subclass: #OBBrowserResource
	instanceVariableNames: 'model morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBBrowserResource methodsFor: 'accessing' stamp: ''!
model
	^ model! !

!OBBrowserResource methodsFor: 'running' stamp: 'cwp 3/23/2007 23:50'!
setUp
	model := OBBrowser metaNode: self metagraph node: self node.
	model addPanel: (OBDefinitionPanel inBrowser: model).
	morph := OBMorphBuilder build: model! !

OBBrowserResource subclass: #OBImageBrowserResource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBImageBrowserResource methodsFor: 'running' stamp: 'avi 9/17/2005 01:13'!
metagraph
	^ OBSystemBrowser alphabeticalMetaNode! !

!OBImageBrowserResource methodsFor: 'running' stamp: ''!
node
	^ OBEnvironmentNode forImage! !

TestResource subclass: #OBSourceFilesResource
	instanceVariableNames: 'sources'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBSourceFilesResource methodsFor: 'initializing' stamp: ''!
changesStream
	^ ReadStream on: self changesString! !

!OBSourceFilesResource methodsFor: 'initializing' stamp: ''!
changesString
	^ '!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:05'' prior: 16777764!!
one
	^ 4!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 16777864!!
two
	^ 4!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 33554520!!
one
	^ 5!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 33554620!!
two
	^ 5!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 33554720!!
one
	^ 6!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 33554820!!
two
	^ 6!! !!
!!BogusA class methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 16777462!!
three
	^ 2!! !!'! !

!OBSourceFilesResource methodsFor: 'initializing' stamp: ''!
setUp
	sources := StandardSourceFileArray new: 2.
	sources at: 1 put: self sourceStream.
	sources at: 2 put: self changesStream.! !

!OBSourceFilesResource methodsFor: 'initializing' stamp: ''!
sourceStream
	^ ReadStream on: self sourceString! !

!OBSourceFilesResource methodsFor: 'initializing' stamp: ''!
sourceString
	^ '!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:05''!!
one
	^ 1!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06''!!
two
	^ 1!! !!
!!BogusA class methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06''!!
three
	^ 1!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 16777288!!
one
	^ 2!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:06'' prior: 16777372!!
two
	^ 2!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 16777600!!
one
	^ 3!! !!
!!BogusA methodsFor: ''as yet unclassified'' stamp: ''cwp 3/11/2004 20:07'' prior: 16777664!!
two
	^ 3!! !!'! !

!OBSourceFilesResource methodsFor: 'accessing' stamp: ''!
sources
	^ sources! !

OBOpenTest subclass: #OBStandardOpenTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBStandardOpenTest methodsFor: 'tests' stamp: 'avi 9/17/2005 01:29'!
testListBrowseRoot
	self open: [OBSendersBrowser browseRoot: (OBMethodNode on: #one inClass: BogusA)].
	self assert: browser navigationPanel minPanes = 1.
	self assert: browser navigationPanel maxPanes = 2.
	self assert: browser currentNode isNil! !

!OBStandardOpenTest methodsFor: 'tests' stamp: 'avi 9/17/2005 01:37'!
testListBrowseRootTitle
	self open: [OBSendersBrowser 
				browseRoot: (OBMethodNode on: #one inClass: BogusA)
				title: 'My senders of'].
	self assert: browser navigationPanel minPanes = 1.
	self assert: browser navigationPanel maxPanes = 2.
	self assert: browser currentNode isNil.
	self assert: browser defaultLabel = 'My senders of #one'! !

!OBStandardOpenTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 17:44'!
testSystemOpen
	self open: [OBSystemBrowser open].
	self assert: browser navigationPanel minPanes = 4.
	self assert: browser navigationPanel maxPanes = 4.
	self assert: browser currentNode = nil! !

!OBStandardOpenTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 18:31'!
testSystemOpenOnClass
	self open: [OBSystemBrowser openOnClass: BogusA].
	self assert: browser navigationPanel minPanes = 4.
	self assert: browser navigationPanel maxPanes = 4.
	self assert: browser currentNode name = #BogusA! !

!OBStandardOpenTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 17:44'!
testSystemOpenOnClassSelector
	self open: [OBSystemBrowser openOnClass: BogusA selector: #one].
	self assert: browser navigationPanel minPanes = 4.
	self assert: browser navigationPanel maxPanes = 4.
	self assert: browser currentNode name = #one! !

!OBStandardOpenTest methodsFor: 'tests' stamp: 'cwp 12/5/2004 17:52'!
testVersionsOpenOn
	| root |
	root _ OBMethodNode on: #testVersionsOpenOn inClass: self class.
	self open: [OBVersionBrowser openOn: root].
	self assert: browser navigationPanel minPanes = 1.
	self assert: browser navigationPanel maxPanes = 1.
	self assert: browser currentNode isNil.
	self assert: browser root = root! !

BogusTestCase subclass: #OBBogusTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBBogusTest methodsFor: 'support' stamp: 'cwp 12/9/2006 18:58'!
execute: factory on: target for: requestor 
	| command |
	command := factory on: target for: requestor.
	^command execute! !

OBBogusTest subclass: #OBClassCommandTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBClassCommandTest methodsFor: 'support' stamp: 'cwp 11/2/2006 23:45'!
announcer
	^ OBAnnouncer new! !

!OBClassCommandTest methodsFor: 'asserting' stamp: 'cwp 11/2/2006 21:06'!
assertCorrectBrowser: aBrowser
	self assert: (aBrowser isKindOf: OBListBrowser)! !

!OBClassCommandTest methodsFor: 'support' stamp: 'cwp 11/2/2006 21:06'!
classFNode
	^(Smalltalk at: #BogusF) asNode! !

!OBClassCommandTest methodsFor: 'emulating' stamp: 'cwp 11/2/2006 21:06'!
definition: aDefinition
	self assert: aDefinition notNil.
	self assert: aDefinition text = self subclassTemplate. ! !

!OBClassCommandTest methodsFor: 'constants' stamp: 'cwp 11/2/2006 21:06'!
nodeLabels
	^ #('remove' 'rename...' 'copy...' 'subclass template')! !

!OBClassCommandTest methodsFor: 'constants' stamp: 'cwp 11/2/2006 21:06'!
ownClassNode
	^(Smalltalk at: self class name) asNode! !

!OBClassCommandTest methodsFor: 'constants' stamp: 'cwp 11/2/2006 21:06'!
parentLabels
	^ #()! !

!OBClassCommandTest methodsFor: 'constants' stamp: 'cwp 11/2/2006 21:06'!
parentNode
	^ self classCatNode! !

!OBClassCommandTest methodsFor: 'constants' stamp: 'cwp 11/2/2006 21:06'!
selectedNode
	^ self classNode! !

!OBClassCommandTest methodsFor: 'constants' stamp: 'cwp 11/2/2006 21:06'!
subclassTemplate
	^  'BogusA subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''Bogus-Base'''! !

!OBClassCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 21:30'!
testCopy
	| node |
	damage add: #Definition ofClass: #BogusF.
	damage add: #Definition ofClass: #BogusX.
	node _ self classFNode.
	[self execute: OBCmdCopyClass on: node for: self]
		on: OBTextRequest
		do: [:n | n resume: 'BogusX'].
	self assert: (Smalltalk hasClassNamed: #BogusF).
	self assert: (Smalltalk hasClassNamed: #BogusX)! !

!OBClassCommandTest methodsFor: 'tests' stamp: 'cwp 11/3/2006 00:12'!
testRemove
	
	damage add: #Definition ofClass: #BogusF.
	[self execute: OBCmdRemoveClass on: self classFNode for: self]
		on: OBConfirmationRequest
		do: [:n | n resume: true].
	self deny: (Smalltalk hasClassNamed: #BogusF)! !

!OBClassCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 23:46'!
testRename
	
	damage addRenameOf: #BogusF to: #BogusX.
	[self execute: OBCmdRenameClass on: self classFNode for: self]
		on: OBInteractionRequest
		do: [:n | n resume: 'BogusX'].
	self deny: (Smalltalk hasClassNamed: #BogusF).
	self assert: (Smalltalk hasClassNamed: #BogusX)! !

!OBClassCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 23:52'!
testRenameNoReferences
	| newName |
	newName := self class name, 'X'.
	damage addRenameOf: self class name to: newName asSymbol.
	self 
		shouldnt: [[self execute: OBCmdRenameClass on: self class asNode for: self] 
					on: OBTextRequest
					do: [:n | n resume: newName]]
		raise: OBBrowseRequest.
! !

!OBClassCommandTest methodsFor: 'tests' stamp: 'cwp 11/2/2006 23:55'!
testRenamedReferences
	| raised node |
	damage addRenameOf: #BogusA to: #BogusX.
	node _ (Smalltalk at: #BogusA) asNode.
	raised _ false.
	[self execute: OBCmdRenameClass on: node for: self] 
		on: OBTextRequest, OBBrowseRequest
		do: [:n | n isBrowseRequest	
					ifTrue: [self assertCorrectBrowser: n browser.
							raised _ true]
					ifFalse: [n resume: 'BogusX']].
	self assert: raised.! !

OBBogusTest subclass: #OBMethodCommandTest
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBMethodCommandTest methodsFor: 'requestor' stamp: 'cwp 12/9/2006 19:55'!
announce: anObject
	handler value: anObject! !

!OBMethodCommandTest methodsFor: 'tests' stamp: 'cwp 12/9/2006 20:29'!
remove: node
	self remove: node selecting: 'Remove it'! !

!OBMethodCommandTest methodsFor: 'tests' stamp: 'cwp 12/9/2006 20:29'!
remove: node selecting: aString
	
	damage add: node selector ofClass: node class name.
	[self execute: OBCmdRemoveMethod on: node for: self]
		on: OBChoiceRequest
		do: [:n | n select: aString].
! !

!OBMethodCommandTest methodsFor: 'requestor' stamp: 'cwp 12/9/2006 19:57'!
setUp
	super setUp.
	handler _ [:obj]! !

!OBMethodCommandTest methodsFor: 'tests' stamp: 'cwp 12/9/2006 20:23'!
testAsksForConfirmationWhenSendersExist
	| node request |
	node _ OBMethodNode on: #a inClass: BogusA.
	[self execute: OBCmdRemoveMethod on: node for: self]
		on: OBChoiceRequest
		do: [:obj | request _ obj].
	self deny: request isNil.
	self assert: (request prompt beginsWith: 'This message has').
	self assert: (request prompt endsWith: 'senders.').
	self assert: request labels =  #('Remove it' 
								'Remove, then browse senders' 
								'Don''t remove, but show me those senders' 
								'Forget it -- do nothing -- sorry I asked')! !

!OBMethodCommandTest methodsFor: 'tests' stamp: 'cwp 12/9/2006 20:39'!
testBrowseSenders
	| node request |
	node _ OBMethodNode on: #a inClass: BogusA.
	[self remove: node selecting: 'Don''t remove, but show me those senders' ]
		on: OBInteractionRequest 
		do: [:obj | request _ obj].
	self deny: request isNil.
	self assert: (request isKindOf: OBBrowseRequest).
	self assert: request browser currentOrRootNode = node! !

!OBMethodCommandTest methodsFor: 'tests' stamp: 'cwp 12/9/2006 21:13'!
testDoNothing
	| node |
	node _ OBMethodNode on: #a inClass: BogusA.
	[self remove: node selecting: 'Forget it -- do nothing -- sorry I asked']
		on: OBInteractionRequest 
		do: [:obj | self assert: false].! !

!OBMethodCommandTest methodsFor: 'tests' stamp: 'cwp 12/11/2006 21:51'!
testMoveToPackage
	| node package |
	damage add: #Categories ofClass: #BogusA.
	node _ OBMethodNode on: #a inClass: BogusA.
	[self execute: OBCmdMoveToPackage on: node for: self]
		on: OBInteractionRequest
		do: [:request | request select: 'OB-Tests-Standard'].
	package _ PackageInfo named: 'OB-Tests-Standard'.
	self assert: (package includesMethodReference: node reference)! !

!OBMethodCommandTest methodsFor: 'tests' stamp: 'cwp 12/11/2006 21:51'!
testMoveToPackageOffersChoice
	| node request |
	damage add: #Categories ofClass: #BogusA.
	node _ OBMethodNode on: #a inClass: BogusA.
	[self execute: OBCmdMoveToPackage on: node for: self]
		on: OBInteractionRequest
		do: [:obj | request _ obj].
	self deny: request isNil.
	self assert: (request isKindOf: OBChoiceRequest).
	self assert: (request labels includes: 'OB-Tests-Standard').! !

!OBMethodCommandTest methodsFor: 'tests' stamp: 'cwp 12/11/2006 21:08'!
testRemovalAnnounced
	
	| node ann |
	damage add: #a ofClass: #BogusA.
	handler _ [:obj | ann _ obj].
	node _ OBMethodNode on: #a inClass: BogusA.
	self remove: node.
	self deny: ann isNil.
	self assert: (ann isKindOf: OBNodeDeleted).
	self assert: ann node = node! !

!OBMethodCommandTest methodsFor: 'tests' stamp: 'cwp 12/11/2006 21:08'!
testRemoveAndBrowseSenders
	| node request |
	damage add: #a ofClass: #BogusA.
	node _ OBMethodNode on: #a inClass: BogusA.
	[self remove: node selecting: 'Remove, then browse senders']
		on: OBInteractionRequest 
		do: [:obj | request _ obj].
	self deny: request isNil.
	self assert: (request isKindOf: OBBrowseRequest).
	self assert: request browser currentOrRootNode = node! !

!OBMethodCommandTest methodsFor: 'tests' stamp: 'cwp 12/11/2006 21:16'!
testRemoveAndBrowseSendersRemoval
	| node |
	damage add: #a ofClass: #BogusA.
	node _ OBMethodNode on: #a inClass: BogusA.
	[self remove: node selecting: 'Remove, then browse senders']
		on: OBInteractionRequest 
		do: [:obj | obj resume].
	self deny: (BogusA includesSelector: #a)
! !

!OBMethodCommandTest methodsFor: 'tests' stamp: 'cwp 12/11/2006 21:08'!
testRemoveMethod
	
	| node |
	damage add: #a ofClass: #BogusA.
	node _ OBMethodNode on: #a inClass: BogusA.
	self remove: node.
	self deny: (BogusA includesSelector: #a)
	! !

!OBMethodCommandTest methodsFor: 'tests' stamp: 'cwp 12/11/2006 21:08'!
testRemoveMethodConfirmed
	
	| node |
	damage add: #a ofClass: #BogusA.
	node _ OBMethodNode on: #a inClass: BogusA.
	[self remove: node]
		on: OBInteractionRequest
		do: [:req | self assert: false].
	self deny: (BogusA includesSelector: #a)
	! !

!OBMethodCommandTest methodsFor: 'tests' stamp: 'cwp 12/11/2006 22:23'!
testRemoveMethodNoInteraction
	
	| node selector |
	selector _ 'bogusUnsentSelector' asSymbol.
	damage add: selector ofClass: #BogusA.
	node _ OBMethodNode on: selector inClass: BogusA.
	[self execute: OBCmdRemoveMethod on: node for: self]
		on: OBInteractionRequest
		do: [:req | self assert: false].
	self deny: (BogusA includesSelector: selector)
	! !

BogusTestCase subclass: #OBOrganizationDefinitionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-Tests-Standard'!

!OBOrganizationDefinitionTest methodsFor: 'constants' stamp: 'cwp 9/22/2004 22:08'!
definition
	^ OBOrganizationDefinition on: BogusA organization! !

!OBOrganizationDefinitionTest methodsFor: 'constants' stamp: 'cwp 12/11/2006 22:34'!
newOrgText
	^ '(''alphanum'' a b five one three two)
(''other'' bogusHopefullyUniqueSelector bogusOtherUniqueSelector bogusUnsentSelector isString)
(''*bogusext'' foo)
(''*bogusext-testing'' isFake)
'
! !

!OBOrganizationDefinitionTest methodsFor: 'constants' stamp: 'cwp 12/11/2006 22:34'!
orgText
	^ '(''letters'' a b)
(''numbers'' five one three two)
(''other'' bogusHopefullyUniqueSelector bogusOtherUniqueSelector bogusUnsentSelector isString)
(''*bogusext'' foo)
(''*bogusext-testing'' isFake)
'! !

!OBOrganizationDefinitionTest methodsFor: 'tests' stamp: 'cwp 6/5/2006 00:19'!
testAccept
	| definition |
	damage add: #Categories ofClass: #BogusA.
	definition _ self definition.
	definition accept: self newOrgText notifying: self.
	self assert: definition text = self newOrgText.
	self assert: BogusA organization asString = self newOrgText! !

!OBOrganizationDefinitionTest methodsFor: 'tests' stamp: 'cwp 9/22/2004 22:31'!
testDisplay
	self assert: self definition text = self orgText! !
